#include "theBiasPlanet/coreUtilities/stringsHandling/StringHandler.hpp"
#include <ctime>
#include <iomanip>
#include <iostream>

namespace theBiasPlanet {
	namespace coreUtilities {
		namespace stringsHandling {
			template <typename T, typename ... U> ostringstream * StringHandler::format (ostringstream * const a_resultStream, istringstream * const a_formatStream, T const & a_currentItem, U const & ... a_remainderItems) {
				if (a_formatStream != nullptr) {
					char l_character = (char) -1;
					bool l_leftPadsItemWith0 = false;
					bool l_lengthOfNumberItemExpressionIsSpecified = false;
					int l_lengthOfNumberItemExpression = -1;
					int l_precisionOfNumberItemExpression = -1;
					ostringstream l_dummyStreamForStoringFormat (GeneralConstantsConstantsGroup::c_emptyString);
					l_dummyStreamForStoringFormat.copyfmt (*a_resultStream);
					while (a_formatStream->get (l_character)) {
						if (l_character == '%') {
							if (a_formatStream->get (l_character)) {
								if (l_character != '%') {
									if (l_character == '0') {
										l_leftPadsItemWith0 = true;
										l_lengthOfNumberItemExpressionIsSpecified = true;
										l_lengthOfNumberItemExpression = 0;
									}
									else {
										l_leftPadsItemWith0 = false;
										if (l_character >= '0' && l_character <= '9') {
											l_lengthOfNumberItemExpressionIsSpecified = true;
											l_lengthOfNumberItemExpression = l_character - '0';
										}
										else {
										}
									}
									if (l_lengthOfNumberItemExpressionIsSpecified) {
										while (a_formatStream->get (l_character)) {
											if (l_character >= '0' && l_character <= '9') {
												if (l_precisionOfNumberItemExpression == -1) {
													l_lengthOfNumberItemExpression = l_lengthOfNumberItemExpression * 10 + (l_character - '0');
												}
												else {
													l_precisionOfNumberItemExpression = l_precisionOfNumberItemExpression * 10 + (l_character - '0');
												}
											}
											else {
												if (l_character == '.') {
													l_precisionOfNumberItemExpression = 0;
												}
												else {
													break;
												}
											}
										}
										if (l_leftPadsItemWith0) {
											(*a_resultStream) << setfill ('0');
										}
										(*a_resultStream) << setw (l_lengthOfNumberItemExpression);
										if (l_precisionOfNumberItemExpression != -1) {
											(*a_resultStream) << fixed << setprecision (l_precisionOfNumberItemExpression);
										}
									}
									if (l_character == 'd') {
										(*a_resultStream) << dec;
									}
									if (l_character == 'x') {
										(*a_resultStream) << uppercase << hex;
									}
									if (l_character == 'b') {
										(*a_resultStream) << boolalpha;
									}
									(*a_resultStream) << a_currentItem;
									a_resultStream->copyfmt (l_dummyStreamForStoringFormat);
									return format (a_resultStream, a_formatStream, a_remainderItems ...);
								}
								else {
									(*a_resultStream) << l_character;
								}
							}
							else {
								(*a_resultStream) << l_character;
							}
						}
						else {
							(*a_resultStream) << l_character;
						}
					}
					(*a_resultStream) << a_currentItem;
					return format (a_resultStream, a_formatStream, a_remainderItems ...);
				}
				else {
					(*a_resultStream) << a_currentItem;
					return format (a_resultStream, a_formatStream, a_remainderItems ...);
				}
			}
			
			template <typename T, typename ... U> string StringHandler::format (string const & a_formatString, T const & a_currentItem, U const & ... a_remainderItems) {
				ostringstream l_resultStream;
				istringstream l_formatStream (a_formatString);
				format (&l_resultStream, &l_formatStream, a_currentItem, a_remainderItems ...);
				return l_resultStream.str ();
			}
			
			template <typename T, typename ... U> ostringstream * StringHandler::format (ostringstream * const a_resultStream, istringstream * const a_formatStream, time_point <T> const & a_currentItem, U const & ... a_remainderItems) {
				if (a_formatStream != nullptr) {
					char l_character = (char) -1;
					ostringstream l_dummyStreamForStoringFormat (GeneralConstantsConstantsGroup::c_emptyString);
					l_dummyStreamForStoringFormat.copyfmt (*a_resultStream);
					while (a_formatStream->get (l_character)) {
						if (l_character == '%') {
							if (a_formatStream->get (l_character)) {
								if (l_character != '%') {
									if (l_character == 'y') {
										//(*a_resultStream) << duration_cast <years> (a_currentItem.time_since_epoch ()).count() << " years"; // 'years' is since C++ 20
										(*a_resultStream) << duration_cast <hours> (a_currentItem.time_since_epoch ()).count() / 24 / 365.2425 << " years";
									}
									else if (l_character == 'm') {
										//(*a_resultStream) << duration_cast <months> (a_currentItem.time_since_epoch ()).count() << " months"; // 'months' is since C++ 20
										(*a_resultStream) << duration_cast <hours> (a_currentItem.time_since_epoch ()).count() / 24 / 30.4167 << " months";
									}
									else if (l_character == 'd') {
										//(*a_resultStream) << duration_cast <days> (a_currentItem.time_since_epoch ()).count() << " days"; // 'days' is since C++ 20
										(*a_resultStream) << duration_cast <hours> (a_currentItem.time_since_epoch ()).count() / 24 << " days";
									}
									else if (l_character == 'H') {
										(*a_resultStream) << duration_cast <hours> (a_currentItem.time_since_epoch ()).count() << " hours";
									}
									else if (l_character == 'M') {
										(*a_resultStream) << duration_cast <minutes> (a_currentItem.time_since_epoch ()).count() << " minutes";
									}
									else if (l_character == 'S') {
										(*a_resultStream) << duration_cast <seconds> (a_currentItem.time_since_epoch ()).count() << " seconds";
									}
									else if (l_character == 'i') {
										(*a_resultStream) << duration_cast <milliseconds> (a_currentItem.time_since_epoch ()).count() << " milliseconds";
									}
									else if (l_character == 'c') {
										(*a_resultStream) << duration_cast <microseconds> (a_currentItem.time_since_epoch ()).count() << " microseconds";
									}
									else if (l_character == 'n') {
										(*a_resultStream) << duration_cast <nanoseconds> (a_currentItem.time_since_epoch ()).count() << " nanoseconds";
									}
									return format (a_resultStream, a_formatStream, a_remainderItems ...);
								}
								else {
									(*a_resultStream) << l_character;
								}
							}
							else {
								(*a_resultStream) << l_character;
							}
						}
						else {
							(*a_resultStream) << l_character;
						}
					}
					return format (a_resultStream, a_formatStream, a_remainderItems ...);
				}
				else {
					return format (a_resultStream, a_formatStream, a_remainderItems ...);
				}
			}
			
			template <typename T, typename ... U> string StringHandler::format (string const & a_formatString, time_point <T> const & a_currentItem, U const & ... a_remainderItems) {
				ostringstream l_resultStream;
				istringstream l_formatStream (a_formatString);
				format (&l_resultStream, &l_formatStream, a_currentItem, a_remainderItems ...);
				return l_resultStream.str ();
			}
			
			template <typename ... U> ostringstream * StringHandler::format (ostringstream * const a_resultStream, istringstream * const a_formatStream, time_point <system_clock> const & a_currentItem, U const & ... a_remainderItems) {
				if (a_formatStream != nullptr) {
					char l_character = (char) -1;
					ostringstream l_dummyStreamForStoringFormat (GeneralConstantsConstantsGroup::c_emptyString);
					l_dummyStreamForStoringFormat.copyfmt (*a_resultStream);
					while (a_formatStream->get (l_character)) {
						if (l_character == '%') {
							if (a_formatStream->get (l_character)) {
								if (l_character != '%') {
									time_t const l_dateAndTimeInTime_t (system_clock::to_time_t (a_currentItem));
									if (l_character == 'y') {
										(*a_resultStream) << put_time (localtime (&l_dateAndTimeInTime_t), "%Y");
									}
									else if (l_character == 'm') {
										(*a_resultStream) << put_time (localtime (&l_dateAndTimeInTime_t), "%Y-%m");
									}
									else if (l_character == 'd') {
										(*a_resultStream) << put_time (localtime (&l_dateAndTimeInTime_t), "%Y-%m-%d");
									}
									else if (l_character == 'H') {
										(*a_resultStream) << put_time (localtime (&l_dateAndTimeInTime_t), "%Y-%m-%dT%H");
									}
									else if (l_character == 'M') {
										(*a_resultStream) << put_time (localtime (&l_dateAndTimeInTime_t), "%Y-%m-%dT%H:%M");
									}
									else if (l_character == 'S') {
										(*a_resultStream) << put_time (localtime (&l_dateAndTimeInTime_t), "%Y-%m-%dT%H:%M:%S");
									}
									else {
										(*a_resultStream) << put_time (localtime (&l_dateAndTimeInTime_t), "%Y-%m-%dT%H:%M:%S.");
										int l_fractionInNanoseconds (floor <nanoseconds> (a_currentItem.time_since_epoch ()).count () - floor <seconds> (a_currentItem.time_since_epoch ()).count () * 1000000000);
										ostringstream l_dummyStreamForStoringFormat (GeneralConstantsConstantsGroup::c_emptyString);
										l_dummyStreamForStoringFormat.copyfmt (*a_resultStream);
										(*a_resultStream) << setfill ('0');
										if (l_character == 'i') {
											(*a_resultStream) << setw (3) << (int) (l_fractionInNanoseconds / 1000000);
										}
										else if (l_character == 'c') {
											(*a_resultStream) << setw (6) << (int) (l_fractionInNanoseconds / 1000);
										}
										else if (l_character == 'n') {
											(*a_resultStream) << setw (9) << l_fractionInNanoseconds;
										}
										a_resultStream->copyfmt (l_dummyStreamForStoringFormat);
									}
									return format (a_resultStream, a_formatStream, a_remainderItems ...);
								}
								else {
									(*a_resultStream) << l_character;
								}
							}
							else {
								(*a_resultStream) << l_character;
							}
						}
						else {
							(*a_resultStream) << l_character;
						}
					}
					return format (a_resultStream, a_formatStream, a_remainderItems ...);
				}
				else {
					return format (a_resultStream, a_formatStream, a_remainderItems ...);
				}
			}
			
			template <typename ... U> string StringHandler::format (string const & a_formatString, time_point <system_clock> const & a_currentItem, U const & ... a_remainderItems) {
				ostringstream l_resultStream;
				istringstream l_formatStream (a_formatString);
				format (&l_resultStream, &l_formatStream, a_currentItem, a_remainderItems ...);
				return l_resultStream.str ();
			}
		}
	}
}

