#include "theBiasPlanet/hiUnoExtensions/models/CplusplusGreeter.hpp"
#include "theBiasPlanet/unoUtilities/collectionsHandling/UnoSequenceHandler.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::theBiasPlanet::unoUtilities::collectionsHandling;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace hiUnoExtensions {
		namespace models {
			OUString CplusplusGreeter::getImplementationNameStatically () {
				return UnoExtendedStringHandler::getOustring (c_nameOfThisClass);
			}
			
			Sequence <OUString> CplusplusGreeter::getSupportedUnoCompoundInterfaceNamesStatically () {
				Sequence <OUString> l_unoCompoundInterfaceNamesSequence;
				UnoSequenceHandler::fillSequence <OUString, string> (&l_unoCompoundInterfaceNamesSequence, c_unoCompoundInterfaceNames);
				return l_unoCompoundInterfaceNamesSequence;
			}
			
			::com::sun::star::uno::Reference <XInterface> SAL_CALL CplusplusGreeter::createInstance (::com::sun::star::uno::Reference <XComponentContext> const & a_underlyingUnoObjectsContextInXComponentContext) {
				return Reference <XInterface> ( (XInterface *) (void *) (new CplusplusGreeter (a_underlyingUnoObjectsContextInXComponentContext)));
			}
			
			CplusplusGreeter::CplusplusGreeter (::com::sun::star::uno::Reference <XComponentContext> const & a_underlyingUnoObjectsContextInXComponentContext): i_remoteUnoObjectsContext (new RemoteUnoObjectsContext (a_underlyingUnoObjectsContextInXComponentContext, string ("UNO extension"))) {
			}
			
			CplusplusGreeter::~CplusplusGreeter () {
			}
			
			void CplusplusGreeter::initialize (Sequence <Any> const & a_arguments) {
				if (a_arguments.getLength () != 1) {
					throw IllegalArgumentException (UnoExtendedStringHandler::getOustring (string ("There must be one argument.")), Reference <XInterface> ( (XInterface *) (void *) this), 0);
				}
				Type l_datumType;
				l_datumType = a_arguments [0].getValueType ();
				if (! (l_datumType == UnoType <OUString>::get ())) {
					throw IllegalArgumentException (UnoExtendedStringHandler::getOustring (string ("The first argument must be a string")), Reference <XInterface> ( (XInterface *) (void *) this), 0);
				}
			    else {
					i_message = UnoExtendedStringHandler::getString (* ( (OUString *) a_arguments [0].getValue ()));
				}
			}
			
			OUString CplusplusGreeter::getImplementationName () {
				return getImplementationNameStatically ();
			}
			
			sal_Bool CplusplusGreeter::supportsService (OUString const & a_unoCompoundInterfaceName) {
				set <string>::iterator l_unoCompoundInterfaceNamesIterator = c_unoCompoundInterfaceNames.find (UnoExtendedStringHandler::getString (a_unoCompoundInterfaceName));
				return (l_unoCompoundInterfaceNamesIterator != c_unoCompoundInterfaceNames.end ());
			}
			
			Sequence <OUString> CplusplusGreeter::getSupportedServiceNames () {
				return getSupportedUnoCompoundInterfaceNamesStatically ();
			}
			
			OUString CplusplusGreeter::sayHi (OUString const & a_name) {
				return UnoExtendedStringHandler::getOustring (i_message + ", ") + a_name + UnoExtendedStringHandler::getOustring ("!");
			}
		}
	}
}

