// # Change the package name
package theBiasPlanet.hiUnoExtensions.models;

import java.util.Set;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import com.sun.star.lang.XInitialization;
import com.sun.star.uno.XComponentContext;
import theBiasPlanet.coreUtilities.collectionsHandling.MapsFactory;
import theBiasPlanet.coreUtilities.collectionsHandling.ArraysFactory;
import theBiasPlanet.unoUtilities.pointers.UnoObjectPointer;
import theBiasPlanet.unoUtilities.unoComponentBases.UnoComponentBase;
import theBiasPlanet.unoUtilities.unoObjectsContexts.RemoteUnoObjectsContext;
// # Add the implemented UNO interface
import theBiasPlanet.unoDatumTypes.hiUnoExtensions.XGreeter;
// # Add the other necessary classes and interfaces Start
// # Add the other necessary classes and interfaces End

// # Change the class name and the implemented UNO interface name
public class JavaGreeter extends UnoComponentBase implements XInitialization, XGreeter {
	private static final Class c_thisClass = new Object () { }.getClass ().getEnclosingClass ();
	private static final Set <String> c_unoServiceNames = new HashSet <String> ();
	private static final Set <String> c_unoCompoundInterfaceNames = new HashSet <String> ();
	private RemoteUnoObjectsContext i_remoteUnoObjectsContext;
	// # Add the other member variables Start
	private String i_message = null;
	// # Add the other member variables End
	
	static {
		// # Add UNO service names Start
		c_unoServiceNames.add ("theBiasPlanet.hiUnoExtensions.JavaGreeter");
		// # Add UNO service names End
		// # Add UNO compound interface names Start
		// # Add UNO compound interface names End
	}
	
	// # Change the class name
	public JavaGreeter (XComponentContext a_underlyingUnoObjectsContextInXComponentContext) throws IllegalArgumentException {
		try {
			i_remoteUnoObjectsContext = new RemoteUnoObjectsContext (new UnoObjectPointer <XComponentContext> (a_underlyingUnoObjectsContextInXComponentContext), "UNO extension");
		}
		catch (Exception l_exception) {
		}
	}
	
	public static void setThisClassToGlobalUnoServicesProvider (Map <String, Map <Class <?>, Set <String>>> a_implementationClassNameToImplementationClassToUnoServiceNamesMapMap) {
		a_implementationClassNameToImplementationClassToUnoServiceNamesMapMap.put (c_thisClass.getName (), MapsFactory. <Class <?>, Set <String>> createLinkedHashMap (c_thisClass, c_unoServiceNames));
	}
	
	public final void initialize (java.lang.Object [] a_arguments) throws com.sun.star.uno.Exception {
		// # Write the initialization Start
		if (a_arguments != null && a_arguments.length == 1) {
			if (a_arguments[0] instanceof String) {
				i_message = (String) a_arguments[0];
				if (i_message == null) {
					throw new IllegalArgumentException ("The first argument can't be null.");
				}
			}
			else {
				throw new IllegalArgumentException("The first argument must be a String instance.");
			}
		}
		else {
			throw new IllegalArgumentException("The number of arguments must be 1.");
		}
		// # Write the initialization End
	}
	
	@Override
	public String getImplementationName () {
		return c_thisClass.getName ();
	}
	
	@Override
	public final boolean supportsService (String a_unoCompoundInterfaceName) {
		return c_unoCompoundInterfaceNames.contains (a_unoCompoundInterfaceName);
	}
	
	@Override
	public final String [] getSupportedServiceNames () {
		return ArraysFactory. <String>createArray (String.class, c_unoCompoundInterfaceNames);
	}
	
	// # Add the methods of the implemented UNO interface Start
	@Override
	public String sayHi (String a_name) throws IllegalArgumentException {
		if (a_name == null) {
			throw new IllegalArgumentException ("The first argument can't be null.");
		}
		return String.format ("%s, %s!", i_message, a_name);
	}
	// # Add the methods of the implemented UNO interface End
	
	// # Add other methods Start
	// # Add other methods End
}

