from typing import Any
from typing import List
from typing import Set
from typing import cast
from collections import OrderedDict
import uno
from com.sun.star.lang import IllegalArgumentException
from com.sun.star.uno import XComponentContext
from theBiasPlanet.unoUtilities.pointers.UnoObjectPointer import UnoObjectPointer
from theBiasPlanet.unoUtilities.unoComponentBases.UnoComponentBase import UnoComponentBase
from theBiasPlanet.unoUtilities.unoObjectsContexts.RemoteUnoObjectsContext import RemoteUnoObjectsContext
# # Add the implemented UNO interface
XGreeter: Any = uno.getClass ("theBiasPlanet.unoDatumTypes.hiUnoExtensions.XGreeter")
# # Add the other necessary classes and interfaces Start
# # Add the other necessary classes and interfaces End

class PythonGreeter (UnoComponentBase, XGreeter):
	c_thisClass: type = None
	c_unoServiceNames: Set [str] = set ()
	c_unoCompoundInterfaceNames: Set [str] = set ()
	# # Add UNO service names Start
	c_unoServiceNames.add ("theBiasPlanet.hiUnoExtensions.PythonGreeter")
	# # Add UNO service names End
	# # Add UNO compound interface names Start
	# # Add UNO compound interface names End
	
	@staticmethod
	def setThisClassToGlobalUnoServicesProvider (a_implementationClassNameToImplementationClassToUnoServiceNamesMapMap: "OrderedDict [str, OrderedDict [type, Set [str]]]")-> None:
		l_implementationClassToUnoServiceNamesMap: "OrderedDict [type, Set [str]]" = OrderedDict ()
		l_implementationClassToUnoServiceNamesMap.update ( {PythonGreeter.c_thisClass: PythonGreeter.c_unoServiceNames})
		a_implementationClassNameToImplementationClassToUnoServiceNamesMapMap.update ( {"{0:s}.{1:s}".format (PythonGreeter.c_thisClass.__module__, PythonGreeter.c_thisClass.__name__): l_implementationClassToUnoServiceNamesMap})
	
	def __init__ (a_this: "PythonGreeter", a_underlyingUnoObjectsContextInXComponentContext: XComponentContext, a_message: str) -> None:
		a_this.i_remoteUnoObjectsContext: "RemoteUnoObjectsContext"
		# # Add the other member variables Start
		a_this.i_message: str
		# # Add the other member variables End
		
		a_this.i_remoteUnoObjectsContext = RemoteUnoObjectsContext (UnoObjectPointer (XComponentContext, a_underlyingUnoObjectsContextInXComponentContext), "UNO extension")
		a_this.i_message = None
		
		# initialization Start
		a_this.i_message = a_message
		if a_this.i_message is None:
			raise IllegalArgumentException ("The first argument can't be null.")
		# initialization End
	
	def __del__ (a_this: "PythonGreeter") -> None:
		None
	
	def getImplementationName (a_this: "PythonGreeter") -> str:
		return "{0:s}.{1:s}".format (PythonGreeter.c_thisClass.__module__, PythonGreeter.c_thisClass.__name__)
	
	def supportsService (a_this: "PythonGreeter", a_unoCompoundInterfaceName: str) -> bool:
		return a_unoCompoundInterfaceName in PythonGreeter.c_unoCompoundInterfaceNames
	
	def getSupportedServiceNames (a_this: "PythonGreeter") -> List [str]:
		l_numberOfItems: int = len (PythonGreeter.c_unoCompoundInterfaceNames)
		l_unoCompoundInterfaceNamesArray: List [str] = [None] * l_numberOfItems
		l_itemIndex: int = 0
		l_unoCompoundInterfaceName: str = None
		for l_unoCompoundInterfaceName in PythonGreeter.c_unoCompoundInterfaceNames:
			l_unoCompoundInterfaceNamesArray [l_itemIndex] = l_unoCompoundInterfaceName
			l_itemIndex = l_itemIndex + 1
		return l_unoCompoundInterfaceNamesArray
	
	# # Add the methods of the implemented UNO interface Start
	def sayHi (a_this: "PythonGreeter", a_name: str)-> str:
		if a_name is None:
			raise IllegalArgumentException ("The first argument can't be null.")
		return "{0:s}, {1:s}!".format (a_this.i_message, a_name)
	# # Add the methods of the implemented UNO interface End
	
	# # Add other methods Start
	# # Add other methods End

PythonGreeter.c_thisClass = PythonGreeter

