#include "theBiasPlanet/unoUtilities/collectionsHandling/UnoSequenceHandler.hpp"
#include <iomanip>
#include <iostream>
#include "theBiasPlanet/coreUtilities/constantsGroups/GeneralConstantsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/unoDataHandling/UnoDatumConverter.hpp"

using namespace ::theBiasPlanet::coreUtilities::constantsGroups;
using namespace ::theBiasPlanet::unoUtilities::unoDataHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace collectionsHandling {
			template <typename T, typename U> Sequence <T> * UnoSequenceHandler::fillSequence (Sequence <T> * a_destinationSequence, list <U> const & a_sourceList) {
				a_destinationSequence->realloc (a_sourceList.size ());
				int l_sequenceElementIndex = GeneralConstantsConstantsGroup::c_iterationStartNumber;
				for (U const & l_listElement: a_sourceList) {
					(*a_destinationSequence) [l_sequenceElementIndex] = UnoDatumConverter::convertToUnoDatum (l_listElement);
					l_sequenceElementIndex ++;
				}
				return a_destinationSequence;
			}
			
			template <typename T, typename U> Sequence <T> * UnoSequenceHandler::fillSequence (Sequence <T> * a_destinationSequence, set <U> const & a_sourceSet) {
				a_destinationSequence->realloc (a_sourceSet.size ());
				int l_sequenceElementIndex = GeneralConstantsConstantsGroup::c_iterationStartNumber;
				for (U const & l_setElement: a_sourceSet) {
					(*a_destinationSequence) [l_sequenceElementIndex] = UnoDatumConverter::convertToUnoDatum (l_setElement);
					l_sequenceElementIndex ++;
				}
				return a_destinationSequence;
			}
			
			template <typename T, typename U> list <T> * UnoSequenceHandler::fillList (list <T> * a_destinationList, Sequence <U> const & a_sourceSequence) {
				int l_numberOfSequenceElements = a_sourceSequence.getLength ();
				for (int l_sequenceElementIndex = GeneralConstantsConstantsGroup::c_iterationStartNumber; l_sequenceElementIndex < l_numberOfSequenceElements; l_sequenceElementIndex ++) {
					a_destinationList->push_back (UnoDatumConverter::convertToNonUnoDatum (a_sourceSequence [l_sequenceElementIndex]));
				}
				return a_destinationList;
			}
			
			template <typename T> string UnoSequenceHandler::toString (Sequence <T> const & a_sequence) {
				ostringstream l_stringStream;
			   	l_stringStream << string (1, GeneralConstantsConstantsGroup::c_jsonArrayOpener);
				int l_numberOfSequenceElements = a_sequence.getLength ();
				for (int l_sequenceElementIndex = GeneralConstantsConstantsGroup::c_iterationStartNumber; l_sequenceElementIndex < l_numberOfSequenceElements; l_sequenceElementIndex ++) {
					if (l_sequenceElementIndex == GeneralConstantsConstantsGroup::c_iterationStartNumber) {
					}	
					else {
						l_stringStream << GeneralConstantsConstantsGroup::c_commaDelimiter;
					}
					l_stringStream << UnoDatumConverter::convertToNonUnoDatum (a_sequence [l_sequenceElementIndex]);
				}
				l_stringStream << string (1, GeneralConstantsConstantsGroup::c_jsonArrayCloser);
				return l_stringStream.str ();
			}
		}
	}
}

