#include "theBiasPlanet/unoUtilities/connectionsHandling/UnoConnectionsFactory.hpp"
#include <optional>
#include <map>
#include <com/sun/star/bridge/BridgeExistsException.hpp>
#include <com/sun/star/bridge/XBridge.hpp>
#include <com/sun/star/uno/XComponentContext.hpp>
#include "theBiasPlanet/coreUtilities/messagingHandling/Publisher.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoMessagesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoServiceNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoObjectsContextPropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::theBiasPlanet::coreUtilities::messagingHandling;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups::propertyNamesSets;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace connectionsHandling {
			UnoConnectionsFactory::UnoConnectionsFactory (UnoObjectPointer <LocalUnoObjectsContext> & a_localUnoObjectsContext): i_localUnoObjectsContext (a_localUnoObjectsContext) {
			}
			
			UnoConnectionsFactory::~UnoConnectionsFactory () {
			}
			
			void UnoConnectionsFactory::initialize () {
				i_unoBridgesFactory.setPrimaryAddress <XInterface> (i_localUnoObjectsContext->getUnoServiceInstance (UnoServiceNamesConstantsGroup::c_com_sun_star_bridge_BridgeFactory, nullopt), true);
			}
			
			UnoObjectPointer <UnoConnection> const UnoConnectionsFactory::setUpUnoConnection (UnoObjectPointer <XConnection> & a_unoConnection, StringTokenizer * const a_urlTokenizer, string const & a_unoConnectionIdentification, optional <list <UnoConnection::UnoConnectionEventsListener *>> const & a_eventsListeners) {
				UnoObjectPointer <UnoConnection::InitialUnoObjectsProvider> l_initialUnoObjectsProvider (new UnoConnection::InitialUnoObjectsProvider (i_localUnoObjectsContext));
				UnoObjectPointer <XBridge> l_unoBridge;
				try {
					l_unoBridge.setPrimaryAddress (i_unoBridgesFactory->createBridge (OUString (), UnoExtendedStringHandler::getOustring (a_urlTokenizer->nextToken ().value ()), a_unoConnection.getPointerInReference (), l_initialUnoObjectsProvider.getPointerInReference <XInstanceProvider> ()));
				}
				catch (BridgeExistsException l_exception) {
					// This can't happen
				}
				if (!l_unoBridge.isEmpty ()) {
					string l_remoteInitialUnoObjectName = a_urlTokenizer->nextToken ().value ();
					UnoObjectPointer <XInterface> l_remoteUnoObjectsContext (l_unoBridge->getInstance (UnoExtendedStringHandler::getOustring (l_remoteInitialUnoObjectName)));
					if (l_remoteUnoObjectsContext.isEmpty ()) {
						throw runtime_error (UnoMessagesConstantsGroup::c_remoteInstanceNotProvided);
					}
					return UnoObjectPointer <UnoConnection> (new UnoConnection (UnoObjectPointer <XComponentContext> (l_remoteUnoObjectsContext.getPointerInReference <XComponentContext> (true)), a_unoConnectionIdentification, l_unoBridge, l_initialUnoObjectsProvider, a_eventsListeners));
				}
				else {
					return UnoObjectPointer <UnoConnection> ();
				}
			}
		}
	}
}

