#include "theBiasPlanet/unoUtilities/displayElements/UnoDesktop.hpp"
#include <com/sun/star/frame/FrameSearchFlag.hpp>
#include <com/sun/star/frame/XComponentLoader.hpp>
#include <com/sun/star/frame/XDispatchProvider.hpp>
#include <com/sun/star/frame/XDesktop.hpp>
#include <com/sun/star/frame/XFrame.hpp>
#include "theBiasPlanet/coreUtilities/collectionsHandling/ListsFactory.hpp"
#include <theBiasPlanet/coreUtilities/constantsGroups/GeneralConstantsConstantsGroup.hpp>
#include "theBiasPlanet/coreUtilities/constantsGroups/RegularExpressionsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoGeneralConstantsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoServiceNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoSingletonNamesConstantsGroup.hpp"
#include <theBiasPlanet/unoUtilities/constantsGroups/UnoSpecialFrameNamesConstantsGroup.hpp>
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoDocumentOpeningEnumerablePropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/propertiesHandling/UnoPropertiesHandler.hpp"
#include <theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp>
#include <theBiasPlanet/unoUtilities/unoDataHandling/UnoDatumConverter.hpp>

using namespace ::com::sun::star::frame;
using namespace ::theBiasPlanet::coreUtilities::collectionsHandling;
using namespace ::theBiasPlanet::coreUtilities::constantsGroups;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups::propertyNamesSets;
using namespace ::theBiasPlanet::unoUtilities::dispatchingHandling;
using namespace ::theBiasPlanet::unoUtilities::propertiesHandling;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;
using namespace ::theBiasPlanet::unoUtilities::unoDataHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace displayElements {
			UnoObjectPointer <UnoDesktop> UnoDesktop::getInstance (UnoObjectPointer <RemoteUnoObjectsContext> & a_remoteUnoObjectsContext) {
				return	UnoObjectPointer <UnoDesktop> (new UnoDesktop (a_remoteUnoObjectsContext));
			}
			
			UnoDesktop::UnoDesktop (UnoObjectPointer <RemoteUnoObjectsContext> & a_remoteUnoObjectsContext): UnoFrame (a_remoteUnoObjectsContext, UnoObjectPointer <XFrame> ( * ( (Reference <XInterface> *) (a_remoteUnoObjectsContext->getValueByName (UnoExtendedStringHandler::getOustring (StringHandler::format (UnoGeneralConstantsConstantsGroup::c_singletonUrlFormat, UnoSingletonNamesConstantsGroup::c_com_sun_star_frame_theDesktop))).getValue ())))), i_fileOpeningDispatcher (i_underlyingUnoObject.getPointerInReference <XDispatchProvider> (true)->queryDispatch (UnoDatumConverter::getUrlInURL ("file:///"), UnoExtendedStringHandler::getOustring (UnoSpecialFrameNamesConstantsGroup::c_new), GeneralConstantsConstantsGroup::c_unspecifiedInteger)) {
			}
			
			UnoDesktop::~UnoDesktop () {
			}
			
			list <UnoObjectPointer <XComponent>> UnoDesktop::getChildObjects () {
				/*
				List <XComponent> l_childObjectsInXComponents = ListsFactory. <XComponent>createArrayList ();
				XEnumeration l_childObjectsIteratorInXEnumeration = i_self.getComponents ().createEnumeration ();
				XComponent l_childObjectInXComponent = null;
				while (l_childObjectsIteratorInXEnumeration.hasMoreElements ()) {
					try {
						l_childObjectInXComponent = (XComponent) UnoRuntime.queryInterface (XComponent.class, l_childObjectsIteratorInXEnumeration.nextElement ());
						if (l_childObjectInXComponent != null) {
							l_childObjectsInXComponents.add (l_childObjectInXComponent);
						}
					}
					catch (NoSuchElementException | WrappedTargetException l_exception) {
						// Practically, never would happen
						break;
					}
				}
				return l_childObjectsInXComponents;
				*/
				return list <UnoObjectPointer <XComponent>> {};
			}
			
			UnoObjectPointer <XComponent> UnoDesktop::getChildObject (string const & a_title) {
				/*
				XEnumeration l_childObjectsIteratorInXEnumeration = i_self.getComponents ().createEnumeration ();
				XTitle l_childObjectInXTitle = null;
				while (l_childObjectsIteratorInXEnumeration.hasMoreElements ()) {
					try {
						l_childObjectInXTitle = (XTitle) UnoRuntime.queryInterface (XTitle.class, l_childObjectsIteratorInXEnumeration.nextElement ());
						if (l_childObjectInXTitle != null) {
							if (l_childObjectInXTitle.getTitle ().equals (a_title) ) {
								return (XComponent) UnoRuntime.queryInterface (XComponent.class, l_childObjectInXTitle);
							}
						}
					}
					catch (NoSuchElementException | WrappedTargetException l_exception) {
						// Practically, never would happen
						break;
					}
				}
				return null;
				*/
				return UnoObjectPointer <XComponent> ();
			}
			
			UnoObjectPointer <XModel> UnoDesktop::loadUnoDocument (string const & a_url, optional <string> const & a_password, bool const & a_unoDocumentIsHidden) {
				string l_convertedUrl (a_url);
				return UnoObjectPointer <XModel> (i_underlyingUnoObject.getPointerInReference <XComponentLoader> (true)->loadComponentFromURL (UnoExtendedStringHandler::getOustring (StringHandler::replaceAll (&l_convertedUrl, RegularExpressionsConstantsGroup::c_windowsDirectoryDelimiterRegularExpression, string (1, GeneralConstantsConstantsGroup::c_linuxDirectoriesDelimiter))), UnoExtendedStringHandler::getOustring (UnoSpecialFrameNamesConstantsGroup::c_new), FrameSearchFlag::CREATE, UnoPropertiesHandler::buildPropertiesSequence (UnoDocumentOpeningEnumerablePropertyNamesSet::c_instance.getValues (), ListsFactory::createList <Any, Any, Any, Any, Any> (Any (false), Any (a_unoDocumentIsHidden), Any (false), Any (a_unoDocumentIsHidden), Any (UnoExtendedStringHandler::getOustring (a_password.has_value () ? *a_password : GeneralConstantsConstantsGroup::c_emptyString))))));
			}
			
			UnoObjectPointer <UnoFrame> UnoDesktop::getCurrentUnoFrame () {
				return UnoObjectPointer <UnoFrame> (new UnoFrame (i_remoteUnoObjectsContext, UnoObjectPointer <XFrame> (i_underlyingUnoObject.getPointerInReference <XDesktop> (true)->getCurrentFrame ())));
			}
			
			UnoObjectPointer <XModel> UnoDesktop::getCurrentDocument () {
				return UnoObjectPointer <XModel> (i_underlyingUnoObject.getPointerInReference <XDesktop> (true)->getCurrentComponent ());
			}
			
			optional <UnoObjectPointer <XModel>> UnoDesktop::getDocument (string const & a_fileName) {
				/*
				XEnumeration l_unoComponentsInXEnumeration = i_self.getComponents ().createEnumeration ();
				while (l_unoComponentsInXEnumeration.hasMoreElements ()) {
					XStorable2 l_unoComponentInXStorable2 = null;
					try {
						l_unoComponentInXStorable2 = (XStorable2) UnoRuntime.queryInterface (XStorable2.class, l_unoComponentsInXEnumeration.nextElement ());
					}
					catch (NoSuchElementException | WrappedTargetException l_exception) {
						// Practically, never would happen
						break;
					}
					if (l_unoComponentInXStorable2 == null) {
						continue;
					}
					try {
						if (Paths.get (l_unoComponentInXStorable2.getLocation ()).getFileName ().toString ().equals (a_fileName)) {
							return (XComponent) UnoRuntime.queryInterface (XComponent.class, l_unoComponentInXStorable2);
						}
					}
					// The possibility is that 'getLocation' returned null.
					catch (IllegalArgumentException l_exception) {
						continue;
					}
				}
				return null;
				*/
				//return UnoObjectPointer <XModel> ();
				return nullopt;
			}
			
			UnoObjectPointer <XSynchronousDispatch> & UnoDesktop::getFileOpeningUnoDispatcher () {
				return i_fileOpeningDispatcher;
			}
		}
	}
}

