#include "theBiasPlanet/unoUtilities/documents/UnoDocument.hpp"
#include <optional>
#include <com/sun/star/frame/FrameSearchFlag.hpp>
#include <com/sun/star/frame/XComponentLoader.hpp>
#include <com/sun/star/frame/XModel.hpp>
#include <com/sun/star/frame/XStorable2.hpp>
#include <com/sun/star/util/XCloseable.hpp>
#include "theBiasPlanet/coreUtilities/collectionsHandling/ArraysFactory.hpp"
#include "theBiasPlanet/coreUtilities/collectionsHandling/ListsFactory.hpp"
#include "theBiasPlanet/coreUtilities/constantsGroups/GeneralConstantsConstantsGroup.hpp"
#include "theBiasPlanet/coreUtilities/constantsGroups/RegularExpressionsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoMessagesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoServiceNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoSpecialFrameNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoDispatchesCommonArgumentEnumerablePropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoDocumentOpeningEnumerablePropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/propertiesHandling/UnoPropertiesHandler.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::com::sun::star::frame;
using namespace ::theBiasPlanet::coreUtilities::collectionsHandling;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups::propertyNamesSets;
using namespace ::theBiasPlanet::unoUtilities::propertiesHandling;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace documents {
			UnoDocument UnoDocument::openDocumentFile (UnoObjectPointer <UnoDesktop> & a_unoDesktop, string const & a_fileUrl, optional <string> const & a_password, bool const & a_unoDocumentIsHidden) {
				return UnoDocument (a_unoDesktop->getRemoteUnoObjectsContext (), a_unoDesktop->loadUnoDocument (a_fileUrl, a_password, a_unoDocumentIsHidden));
			}
			
			UnoDocument UnoDocument::getCurrentDocument (UnoObjectPointer <UnoDesktop> & a_unoDesktop) {
				return UnoDocument (a_unoDesktop->getRemoteUnoObjectsContext (), a_unoDesktop->getCurrentDocument ());
			}
			
			UnoDocument::UnoDocument (UnoObjectPointer <RemoteUnoObjectsContext> & a_remoteUnoObjectsContext, UnoObjectPointer <XModel> const & a_underlyingUnoObject): i_remoteUnoObjectsContext (a_remoteUnoObjectsContext), i_underlyingUnoObject (a_underlyingUnoObject), i_unoController (i_underlyingUnoObject->getCurrentController ()), i_unoFrame (new UnoFrame (i_remoteUnoObjectsContext, UnoObjectPointer <XFrame> (i_unoController->getFrame ()))) {
				if (i_remoteUnoObjectsContext.isEmpty ()) {
					throw runtime_error (UnoMessagesConstantsGroup::c_unoObjectsContextNotSpecified);
				}
				if (i_underlyingUnoObject.isEmpty ()) {
					throw runtime_error (UnoMessagesConstantsGroup::c_unoDocumentNotSpecified);
				}
				//i_unoFrame.setPrimaryAddress (i_unoController->getFrame ());
			}
			
			UnoDocument::~UnoDocument () {
			}
			
			UnoObjectPointer <RemoteUnoObjectsContext> & UnoDocument::getRemoteUnoObjectsContext () {
				return i_remoteUnoObjectsContext;
			}
			
			UnoObjectPointer <XModel> & UnoDocument::getUnderlyingUnoObject () {
				return i_underlyingUnoObject;
			}
			
			UnoObjectPointer <UnoFrame> & UnoDocument::getUnoFrame () {
				return i_unoFrame;
			}
			
			void UnoDocument::store () {
			}
			
			void UnoDocument::storeAtUrl (string const & a_fileUrl) {
			}
			
			string UnoDocument::getUrl () {
				return UnoExtendedStringHandler::getString (i_underlyingUnoObject.getPointerInReference <XStorable2> ()->getLocation ());
			}
			
			void UnoDocument::close () {
				i_underlyingUnoObject.getPointerInReference <XCloseable> (true)->close (false); 
			}
			
			/*
			optional <UnoDispatchResultAndRelatedInformation> UnoDocument::fulfill (UnoDispatchSlotsConstantsGroup::BaseUnoDispatchSlot const & a_unoDispatchSlot, optional <list <Any>> const & a_unoDispatchArgumentValues) {
				unique_lock <recursive_mutex> l_lock (i_mutex);
				if (i_unoDispatchResultAndRelatedInformation != nullptr) {
					delete i_unoDispatchResultAndRelatedInformation;
					i_unoDispatchResultAndRelatedInformation = nullptr;
				}
				i_unoDispatchResultAndRelatedInformation = new UnoDispatchResultAndRelatedInformation ();
				if (UnoFulfiller::fulfill (i_unoFrame, UnoObjectPointer <XDispatchResultListener> (this), UnoObjectPointer <XStatusListener> (this), a_unoDispatchSlot, a_unoDispatchArgumentValues)) {
					return optional <UnoDispatchResultAndRelatedInformation> (*i_unoDispatchResultAndRelatedInformation);
				}
				else {
					i_unoDispatchResultAndRelatedInformation = nullptr;
					return nullopt;
				}
			}
			*/
		}
	}
}

