#include "theBiasPlanet/unoUtilities/documents/UnoSpreadSheetsDocument.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoMessagesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoSpecialFileUrlsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::theBiasPlanet::unoUtilities::constantsGroups;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace documents {
			UnoSpreadSheetsDocument UnoSpreadSheetsDocument::createDocument (UnoObjectPointer <UnoDesktop> & a_unoDesktop, bool const & a_unoDocumentIsHidden) {
				return UnoSpreadSheetsDocument (a_unoDesktop->getRemoteUnoObjectsContext (), a_unoDesktop->loadUnoDocument (UnoSpecialFileUrlsConstantsGroup::c_calcNewDocument, nullopt, a_unoDocumentIsHidden));
			}
			
			UnoSpreadSheetsDocument UnoSpreadSheetsDocument::openFile (UnoObjectPointer <UnoDesktop> & a_unoDesktop, string const & a_fileUrl, optional <string> const & a_password, bool const & a_unoDocumentIsHidden) {
				return UnoSpreadSheetsDocument (a_unoDesktop->getRemoteUnoObjectsContext (), a_unoDesktop->loadUnoDocument (a_fileUrl, a_password, a_unoDocumentIsHidden));
			}
			
			UnoSpreadSheetsDocument UnoSpreadSheetsDocument::getCurrentDocument (UnoObjectPointer <UnoDesktop> & a_unoDesktop) {
				return UnoSpreadSheetsDocument (a_unoDesktop->getRemoteUnoObjectsContext (), a_unoDesktop->getCurrentDocument ());
			}
			
			UnoSpreadSheetsDocument::UnoSpreadSheetsDocument (UnoObjectPointer <RemoteUnoObjectsContext> & a_remoteUnoObjectsContext, UnoObjectPointer <XModel> && a_spreadSheetsDocument) : UnoDocument (a_remoteUnoObjectsContext, a_spreadSheetsDocument), i_spreadSheetsDocument (i_underlyingUnoObject.getPointerInReference <XSpreadsheetDocument> (true)) {
				if (i_spreadSheetsDocument.isEmpty ()) {
					throw runtime_error (UnoMessagesConstantsGroup::c_isNotSpreadSheetsDocument);
				}
			}
		}
	}
}

