#include "theBiasPlanet/unoUtilities/documents/UnoTextDocument.hpp"
#include <com/sun/star/text/XTextViewCursorSupplier.hpp>
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoMessagesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoSpecialFileUrlsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::theBiasPlanet::unoUtilities::constantsGroups;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace documents {
			UnoTextDocument UnoTextDocument::createDocument (UnoObjectPointer <UnoDesktop> & a_unoDesktop, bool const & a_unoDocumentIsHidden) {
				return UnoTextDocument (a_unoDesktop->getRemoteUnoObjectsContext (), a_unoDesktop->loadUnoDocument (UnoSpecialFileUrlsConstantsGroup::c_writerNewDocument, nullopt, a_unoDocumentIsHidden));
			}
			
			 UnoTextDocument UnoTextDocument::openFile (UnoObjectPointer <UnoDesktop> & a_unoDesktop, string const & a_fileUrl, optional <string> const & a_password, bool const & a_unoDocumentIsHidden) {
				return UnoTextDocument (a_unoDesktop->getRemoteUnoObjectsContext (), a_unoDesktop->loadUnoDocument (a_fileUrl, a_password, a_unoDocumentIsHidden));
			}
			
			UnoTextDocument UnoTextDocument::getCurrentDocument (UnoObjectPointer <UnoDesktop> & a_unoDesktop) {
				return UnoTextDocument (a_unoDesktop->getRemoteUnoObjectsContext (), a_unoDesktop->getCurrentDocument ());
			}
			
			UnoTextDocument::UnoTextDocument (UnoObjectPointer <RemoteUnoObjectsContext> & a_remoteUnoObjectsContext, UnoObjectPointer <XModel> && a_unoTextDocument) : UnoDocument (a_remoteUnoObjectsContext, a_unoTextDocument) {
				i_unoTextDocument.setPrimaryAddress (i_underlyingUnoObject.getPointerInReference <XTextDocument> (true));
				if (i_unoTextDocument.isEmpty ()) {
					throw runtime_error (UnoMessagesConstantsGroup::c_isNotTextDocument);
				}
				i_unoTextViewCursor.setPrimaryAddress (i_unoController.getPointerInReference <XTextViewCursorSupplier> (true)->getViewCursor ());
				i_unoText.setPrimaryAddress (i_unoTextDocument->getText ());
			}
			
			UnoObjectPointer <XTextViewCursor> & UnoTextDocument::getUnoTextViewCursor () {
				return i_unoTextViewCursor;
			}
			
			bool UnoTextDocument::insertText (string const & a_text) {
				getUnoTextViewCursor ()->gotoEnd (false);
				i_unoText->insertString (i_unoTextViewCursor.getPointerInReference <XTextRange> (), UnoExtendedStringHandler::getOustring (a_text), false);
				return true;
			}
		}
	}
}

