#include "theBiasPlanet/unoUtilities/documentsHandling/UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor.hpp"
#include <com/sun/star/container/XIndexAccess.hpp>
#include <com/sun/star/container/XNamed.hpp>
#include <com/sun/star/sheet/XSpreadsheet.hpp>
#include <com/sun/star/sheet/XSpreadsheetDocument.hpp>
#include <com/sun/star/sheet/XSpreadsheets.hpp>
#include "theBiasPlanet/coreUtilities/constantsGroups/GeneralConstantsConstantsGroup.hpp"
#include "theBiasPlanet/coreUtilities/messagingHandling/Publisher.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::com::sun::star::container;
using namespace ::com::sun::star::sheet;
using namespace ::theBiasPlanet::coreUtilities::constantsGroups;
using namespace ::theBiasPlanet::coreUtilities::messagingHandling;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace documentsHandling {
			UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor::UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor (UnoObjectPointer <RemoteUnoObjectsContext> & a_remoteUnoObjectsContext, int a_targetSpreadSheetIndex) : UnoDocumentTailor (a_remoteUnoObjectsContext), i_targetSpreadSheetIndex (a_targetSpreadSheetIndex) {
			}
			
			UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor::UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor (UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor const & a_copiedObject) : UnoDocumentTailor (a_copiedObject) {
			}
			
			UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor::~UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor () {
			}
			
			bool UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor::tailor (UnoObjectPointer <XModel> & a_unoDocument) const {
				if (! (a_unoDocument.getPointerInReference <XSpreadsheetDocument> (true).is ())) {
					Publisher::logErrorInformation (string ("The document is not any spread sheet."));
					return false;
				}
				else {
					UnoObjectPointer <XSpreadsheets> l_spreadSheets (a_unoDocument.getPointerInReference <XSpreadsheetDocument> (true)->getSheets ());
					try {
						UnoObjectPointer <XSpreadsheet> l_spreadSheet (* ( (Reference <XSpreadsheet> *) ( (l_spreadSheets.getPointerInReference <XIndexAccess> (true)->getByIndex (i_targetSpreadSheetIndex)).getValue ())));
						l_spreadSheets.getPointerInReference ()->moveByName (l_spreadSheet.getPointerInReference <XNamed> (true)->getName (), (short) GeneralConstantsConstantsGroup::c_iterationStartNumber);
						return true;
					}
					catch (Exception l_exception) {
						Publisher::logErrorInformation (UnoExtendedStringHandler::getString (l_exception.Message));
						return false;
					}
				}
			}
		}
	}
}

