#ifndef __theBiasPlanet_unoUtilities_fileConversionsHandling_FilesConverter_hpp__
	#define __theBiasPlanet_unoUtilities_fileConversionsHandling_FilesConverter_hpp__
	
	#include <list>
	#include <optional>
	#include <com/sun/star/beans/PropertyValue.hpp>
	#include <com/sun/star/frame/XSynchronousDispatch.hpp>
	#include <com/sun/star/uno/Any.hxx>
	#include <com/sun/star/uno/Sequence.hxx>
	#include <com/sun/star/util/URL.hpp>
	#include "theBiasPlanet/unoUtilities/displayElements/UnoDesktop.hpp"
	#include "theBiasPlanet/unoUtilities/documentsHandling/UnoDocumentTailor.hpp"
	#include "theBiasPlanet/unoUtilities/unoObjectsContexts/RemoteUnoObjectsContext.hpp"
	#include "theBiasPlanet/unoUtilities/visualCplusplusSpecificHeaders/VisualCplusplusSpecificDefinitions.hpp"
	
	using namespace ::std;
	using namespace ::com::sun::star::beans;
	using namespace ::com::sun::star::frame;
	using namespace ::com::sun::star::uno;
	using namespace ::com::sun::star::util;
	using namespace ::rtl;
	using namespace ::theBiasPlanet::unoUtilities::displayElements;
	using namespace ::theBiasPlanet::unoUtilities::documentsHandling;
	using namespace ::theBiasPlanet::unoUtilities::unoObjectsContexts;
	
	namespace theBiasPlanet {
		namespace unoUtilities {
			namespace fileConversionsHandling {
				class __theBiasPlanet_unoUtilities_symbolExportingOrImportingForVisualCplusplus__ FilesConverter {
					private:
						static string const c_csvFormatStringFormat;
						UnoObjectPointer <RemoteUnoObjectsContext>  & i_remoteUnoObjectsContext;
						UnoObjectPointer <XSynchronousDispatch> & i_fileOpeningUnoDispatcher;
					public:
						FilesConverter (UnoObjectPointer <UnoDesktop> & a_unoDesktop);
						virtual ~FilesConverter  ();
						virtual UnoObjectPointer <RemoteUnoObjectsContext> & getRemoteUnoObjectsContext ();
						virtual bool convertFile (string const & a_originalFileUrl, optional <string> const & a_originalFilePassword, string const & a_targetFileUrl, Sequence <PropertyValue> const & a_unoDocumentStoringPropertiesSequence, optional <list <UnoDocumentTailor *>> const & a_unoDocumentTailors);
						static Sequence <PropertyValue> createToCsvFileDocumentStoringPropertiesSequence (int const & a_itemsDelimiterCharacterCode, int const & a_textItemQuotationCharacterCode, int const & a_charactersEncodingCode, bool const & a_whetherAllTextItemsAreQuoted, bool const & a_whetherContentsAreExportedAsShown, bool const & a_whetherFormulaThemselvesAreExported);
						// a_targetFileNamingRule: 0 -> augmented by the sheet index, 1 -> augmented by the sheet name
						virtual bool convertSpreadSheetsDocumentFileToCsvFiles (string const & a_originalFileUrl, optional <string> const & a_originalFilePassword, string const & a_targetFileUrlBase, Sequence <PropertyValue> const & a_unoDocumentStoringPropertiesSequence, optional <list <UnoDocumentTailor *>> const & a_unoDocumentTailors, int const & a_targetFileNamingRule, bool const & a_whetherWritesHiddenSheets);
				};
			}
		}
	}
#endif

