#ifndef __theBiasPlanet_unoUtilities_officeInstance_OfficeInstance_hpp__
	#define __theBiasPlanet_unoUtilities_officeInstance_OfficeInstance_hpp__
	
	#include <condition_variable>
	#include <mutex>
	#include <cppuhelper/compbase1.hxx>
	#include "theBiasPlanet/unoDatumTypes/unoUtilities/officeInstance/XOfficeInstance.hpp"
	#include "theBiasPlanet/unoUtilities/pointers/UnoObjectPointer.hpp"
	#include "theBiasPlanet/unoUtilities/displayElements/UnoDesktop.hpp"
	#include "theBiasPlanet/unoUtilities/unoComponentBases/UnoComponentBase.hpp"
	#include "theBiasPlanet/unoUtilities/unoObjectsContexts/RemoteUnoObjectsContext.hpp"
	#include "theBiasPlanet/unoUtilities/visualCplusplusSpecificHeaders/VisualCplusplusSpecificDefinitions.hpp"
	
	using namespace ::std;
	using namespace ::cppu;
	using namespace ::theBiasPlanet::unoDatumTypes::unoUtilities::officeInstance;
	using namespace ::theBiasPlanet::unoUtilities::displayElements;
	using namespace ::theBiasPlanet::unoUtilities::unoComponentBases;
	using namespace ::theBiasPlanet::unoUtilities::unoObjectsContexts;
	
	namespace theBiasPlanet {
		namespace unoUtilities {
			namespace officeInstance {
				class __theBiasPlanet_unoUtilities_symbolExportingOrImportingForVisualCplusplus__ OfficeInstance: public ImplInheritanceHelper1 <UnoComponentBase, XOfficeInstance> {
					private:
						UnoObjectPointer <RemoteUnoObjectsContext> & i_remoteUnoObjectsContext;
						recursive_mutex i_threadsMutex;
						condition_variable_any i_threadsCondition;
						int i_criticalSessionCount;
						bool i_serverIsPlannedToBeTerminated;
						UnoObjectPointer <UnoDesktop> & i_unoDesktop;
					public:
						OfficeInstance (UnoObjectPointer <RemoteUnoObjectsContext> & a_remoteUnoObjectsContext);
						~OfficeInstance ();
						virtual sal_Bool SAL_CALL incrementCriticalSessionCount (OUString const & a_connectionIdentification) override;
						virtual void SAL_CALL decrementCriticalSessionCount (OUString const & a_connectionIdentification) override;
						virtual sal_Int32 SAL_CALL getCriticalSessionCount () override;
						virtual sal_Bool SAL_CALL serverIsPlannedToBeTerminated () override;
						virtual void setServerAsPlannedToBeTerminated ();
						virtual bool waitUntilNoCriticalSession (int a_timeOutInMilliseconds);
						virtual bool terminate (int a_gracePeriodInMillisecondsBeforeForcing);
				};
			}
		}
	}
#endif

