#include "theBiasPlanet/unoUtilities/unoComponentBases/UnoComponentBase.hpp"
#include "theBiasPlanet/coreUtilities/messagingHandling/Publisher.hpp"
#include "theBiasPlanet/coreUtilities/stringsHandling/StringHandler.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::theBiasPlanet::coreUtilities::messagingHandling;
using namespace ::theBiasPlanet::coreUtilities::stringsHandling;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace unoComponentBases {
			UnoComponentBase::UnoComponentBase (): UnoComponentBase (string ("not specified")) {
			}
			
			UnoComponentBase::UnoComponentBase (string const & a_unoComponentName): WeakImplHelper1 <XServiceInfo> (), i_unoComponentName (a_unoComponentName) {
				Publisher::logDebugInformation (StringHandler::format ("### An instance of a local UNO component, '%s', is being created.", i_unoComponentName));
			}
			
			UnoComponentBase::~UnoComponentBase () {
				Publisher::logDebugInformation (StringHandler::format ("### An instance of a local UNO component, '%s', is being deleted.", i_unoComponentName));
			}
			
			string const & UnoComponentBase::getUnoComponentName () {
				return i_unoComponentName;
			}
			
			void SAL_CALL UnoComponentBase::acquire () throw () {
				Publisher::logDebugInformation (StringHandler::format ("### An instance of a local UNO component, '%s', is being pointed to.", i_unoComponentName));
				WeakImplHelper1 <XServiceInfo>::acquire ();
			}
			
			void SAL_CALL UnoComponentBase::release () throw () {
				Publisher::logDebugInformation (StringHandler::format ("### An instance of a local UNO component, '%s', is being de-pointed to.", i_unoComponentName));
				WeakImplHelper1 <XServiceInfo>::release ();
			}
			
			OUString SAL_CALL UnoComponentBase::getImplementationName () {
				return UnoExtendedStringHandler::getOustring (string ("not specified"));
			}
			
			sal_Bool SAL_CALL UnoComponentBase::supportsService (OUString const & a_serviceName) {
				return sal_False;
			}
			
			Sequence <OUString> SAL_CALL UnoComponentBase::getSupportedServiceNames () {
				return Sequence <OUString> ();
			}
		}
	}
}

