namespace theBiasPlanet {
	namespace unoUtilities {
		namespace constantsGroups {
			namespace propertyNamesSets {
				using System;
				using theBiasPlanet.coreUtilities.constantsGroups;
				
				public class UnoPdfExportingPropertyNamesSet : UnoPropertyNamesSet {
					// General
					public const String c_pagesRangeSpecification_string = "PageRange"; // '' -> all the pages, '1-2,4', etc.
					public const String c_exportedSections_any = "Selection"; // the selection gotten by 'XSelectionSupplier.getSelection ()' of the controller of the document, or an arbitrary object (for example, a cells range)
					public const String c_losslessCompressionIsUsed_boolean = "UseLosslessCompression"; // 'false' -> a JPEG compression is used
					public const String c_jpegQuality_short = "Quality"; // in %
					public const String c_imageResolutionsAreReduced_boolean = "ReduceImageResolution";
					public const String c_maximumImageResolution_short = "MaxImageResolution"; // in DPI: 75, 150, 300, 600, or 1200
					public const String c_watermarkString_string = "Watermark";
					public const String c_originalDocumentIsEmbedded_boolean = "IsAddStream";
					public const String c_pdfVersionCode_short = "SelectPdfVersion"; // '0' -> PDF 1.4, '1' -> PDF/A-1
					public const String c_taggedPdfIsUsed_boolean = "UseTaggedPDF";
					public const String c_formFieldsAreExported_boolean = "ExportFormFields";
					public const String c_formsTypeCode_short = "FormsType"; // '0' -> FDF, '1' -> PDF, '2' -> HTML, '3' -> XML
					public const String c_someDuplicateFieldNamesAreAllowed_boolean = "AllowDuplicateFieldNames";
					public const String c_bookmarksAreExported_boolean = "ExportBookmarks";
					public const String c_placeholdersAreExported_boolean = "ExportPlaceholders";
					public const String c_commentsAreExported_boolean = "ExportNotes";
					public const String c_automaticallyInsertedEmptyPagesAreSkipped_boolean = "IsSkipEmptyPages";
					public const String c_formXobjectsAreUsed_boolean = "UseReferenceXObject";
					public const String c_targetFileIsShownAfterExportingHasBeenCompleted_boolean = "ViewPDFAfterExport";
					// Initial View
					public const String c_forAfterExportingShowingOfTargetFileInitialViewStyleCode_short = "InitialView"; // '0' -> pages only, '1' -> bookmarks and pages, '2' -> thumbnails and pages
					public const String c_forAfterExportingShowingOfTargetFileInitialPageNumber_short = "InitialPage";
					public const String c_forAfterExportingShowingOfTargetFileInitialMagnificationTypeCode_short = "Magnification"; // '0' -> default, '1' -> the whole page is fitted into the window, '2' -> the page width is fitted into the window, '3' -> the page contents are supposed to be fitted into the window, but not necessarily are so
					public const String c_forAfterExportingShowingOfTargetFileInitialZoomFactor_short = "Zoom"; // in %
					public const String c_forAfterExportingShowingOfTargetFileInitialPageLayoutStyleCode_short = "PageLayout"; // '0' -> default, '1' -> single page, '2' -> continuous, '3' -> each 2 facing pages are shown abreast and those pairs are shown continuously connected vertically
					public const String c_forAfterExportingShowingOfTargetFileFirstPageIsOnLeft_boolean = "FirstPageOnLeft"; // valid only when 'PageLayout' is '3'
					// User Interface
					public const String c_forAfterExportingShowingOfTargetFileWindowIsResizedToInitialPage_boolean = "ResizeWindowToInitialPage";
					public const String c_forAfterExportingShowingOfTargetFileWindowIsCenteredOnScreen_boolean = "CenterWindow";
					public const String c_forAfterExportingShowingOfTargetFileWindowIsOpenedInFullScreenMode_boolean = "OpenInFullScreenMode";
					public const String c_forAfterExportingShowingOfTargetFileDocumentTitleIsShown_boolean = "DisplayPDFDocumentTitle";
					public const String c_forAfterExportingShowingOfTargetFileTransitionEffectsAreUsed_boolean = "UseTransitionEffects";
					public const String c_forAfterExportingShowingOfTargetFileMenubarIsHidden_boolean = "HideViewerMenubar";
					public const String c_forAfterExportingShowingOfTargetFileToolbarIsHidden_boolean = "HideViewerToolbar";
					public const String c_forAfterExportingShowingOfTargetFileWindowControlsAreHidden_boolean = "HideViewerWindowControls";
					public const String c_forAfterExportingShowingOfTargetFileOpenedBookmarkLevels_short = "OpenBookmarkLevels"; // '-1' -> all
					// Links
					public const String c_bookmarksAreExportedAsNamedDestinations_boolean = " ExportBookmarksToPDFDestination";
					public const String c_documentLinksAreConvertedToPdfTargets_boolean = "ConvertOOoTargetToPDFTarget";
					public const String c_relativeFileLinksAreExported_boolean = "ExportLinksRelativeFsys";
					public const String c_crossDocumentsLinksViewerCode_short = "PDFViewSelection"; // '0' -> the default viewer, '1' -> a PDF reader application, '2' -> an internet browser
					// Security
					public const String c_fileIsEncrypted_boolean = "EncryptFile";
					public const String c_openingPassword_string = "DocumentOpenPassword";
					public const String c_someActionsAreRestricted_boolean = "RestrictPermissions";
					public const String c_restrictedActionsPassword_string = "PermissionPassword";
					public const String c_printingRestrictionCode_short = "Printing"; // '0' -> not permitted, '1' -> only in a low resolution (150 DPI), '2' -> also in high resolutions
					public const String c_changingRestrictionCode_short = "Changes"; // '0' -> not permitted, '1' -> inserting, deleting, and rotating pages, '2' -> filling in form fields, '3' -> commenting and filling in form fields, '4' -> any except extracting pages
					public const String c_copyingOfContentsIsAllowed_boolean = "EnableCopyingOfContent";
					public const String c_textAccessForAccessibilityToolsIsAllowed_boolean = "EnableTextAccessForAccessibilityTools";
					// Digital Signature
					public const String c_fileIsSigned_boolean = "SignPDF";
					public const String c_signatureCertificate_com_sun_star_security_XCertificate = "SignatureCertificate";
					public const String c_signatureCertificatePassword_string = "SignaturePassword";
					public const String c_signatureLocation_string = "SignatureLocation";
					public const String c_signatureReason_string = "SignatureReason";
					public const String c_signatureContactInformation_string = "SignatureContactInfo";
					public const String c_signatureTimeStampAuthorityUrl_string = "SignatureTSA";
				}
			}
		}
	}
}

