namespace theBiasPlanet {
	namespace unoUtilities {
		namespace dispatchingHandling {
			using System;
			using System.Collections.Generic;
			using System.Text;
			using unoidl.com.sun.star.frame;
			using theBiasPlanet.coreUtilities.stringsHandling;
			
			public class UnoDispatchResultAndRelatedInformation {
				private Int16 i_finalStatus;
				private Object i_result;
				private List <Object> i_relatedInformation;
				
				public UnoDispatchResultAndRelatedInformation () {
					i_finalStatus = DispatchResultState.FAILURE;
					i_result = null;
					i_relatedInformation = new List <Object> ();
				}
				
				public Object getResult () {
					return i_result;
				}
				
				public void setResult (DispatchResultEvent a_resultEvent) {
					if (a_resultEvent != null) {
						i_finalStatus = a_resultEvent.State;
						i_result = a_resultEvent.Result;
					}
					else {
						i_result = null;
					}
				}
				
				public List <Object> getRelatedInformation () {
					return i_relatedInformation;
				}
				
				public void addRelatedInformationPiece (FeatureStateEvent a_relatedInformationPieceEvent) {
					if (a_relatedInformationPieceEvent != null) {
						if (a_relatedInformationPieceEvent.State.hasValue ()) {
							i_relatedInformation.Add (a_relatedInformationPieceEvent.State);
						}
						else {
							i_relatedInformation.Add (null);
						}
					}
					else {
						i_relatedInformation.Add (null);
					}
				}
				
				public String toString () {
					StringBuilder l_stringBuilder = new StringBuilder ();
					l_stringBuilder.Append ("State = ");
					l_stringBuilder.Append (String.Format ("{0:d}", i_finalStatus));
					l_stringBuilder.Append (", Result = ");
					if (i_result != null) {
						l_stringBuilder.Append (StringHandler.getString (i_result));
					}
					else {
						l_stringBuilder.Append ("null");
					}
					l_stringBuilder.Append (", Related information = ");
					Boolean l_isInFirstIterationOfRelatedInformationPieces = true;
					foreach (Object l_relatedInformationPiece in i_relatedInformation) {
						if (!l_isInFirstIterationOfRelatedInformationPieces) {
							l_stringBuilder.Append (", ");
						}
						else {
							l_isInFirstIterationOfRelatedInformationPieces = false;
						}
						l_stringBuilder.Append (StringHandler.getString (l_relatedInformationPiece));
					}
					return l_stringBuilder.ToString ();
				}
			}
		}
	}
}

