namespace theBiasPlanet {
	namespace unoUtilities {
		namespace documents {
			using System;
			using System.Collections.Generic;
			using System.Text.RegularExpressions;
			using uno;
			using unoidl.com.sun.star.beans;
			using unoidl.com.sun.star.container;
			using unoidl.com.sun.star.document;
			using unoidl.com.sun.star.frame;
			using unoidl.com.sun.star.lang;
			using unoidl.com.sun.star.script.provider;
			using unoidl.com.sun.star.uno;
			using unoidl.com.sun.star.util;
			using theBiasPlanet.coreUtilities.collectionsHandling;
			using theBiasPlanet.coreUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.constantsGroups.propertyNamesSets;
			using theBiasPlanet.unoUtilities.dispatchingHandling;
			using theBiasPlanet.unoUtilities.displayElements;
			using theBiasPlanet.unoUtilities.pointers;
			using theBiasPlanet.unoUtilities.propertiesHandling;
			using theBiasPlanet.unoUtilities.unoComponentBases;
			using theBiasPlanet.unoUtilities.unoDataHandling;
			using theBiasPlanet.unoUtilities.unoObjectsContexts;
			
			public class UnoDocument {
				protected RemoteUnoObjectsContext i_remoteUnoObjectsContext = null;
				protected UnoObjectPointer <XModel> i_underlyingUnoObject = null;
				protected UnoObjectPointer <XController> i_unoController = null;
				protected UnoFrame i_unoFrame = null;
				protected UnoObjectPointer <XScriptProvider> i_macrosProvider = null;
				/*
				protected RemoteUnoObjectsContext i_remoteUnoObjectsContext;
				protected XModel i_underlyingUnoObject;
				protected XStorable2 i_unoDocumentInXStorable2;
				protected XDocumentEventBroadcaster i_unoDocumentInXDocumentEventBroadcaster;
				protected XEventBroadcaster i_unoDocumentInXEventBroadcaster;
				protected XController i_unoControllerInXController;
				protected XFrame i_unoFrameInXFrame;
				protected XDispatchProvider i_unoFrameInXDispatchProvider;
				protected UnoDispatchResultAndRelatedInformation i_unoDispatchResultAndRelatedInformation;
				*/
				
				public UnoDocument (RemoteUnoObjectsContext a_remoteUnoObjectsContext, UnoObjectPointer <XModel> a_underlyingUnoObject) {
					if (a_remoteUnoObjectsContext == null) {
						throw new System.Exception (UnoMessagesConstantsGroup.c_unoObjectsContextNotSpecified);
					}
					i_remoteUnoObjectsContext = a_remoteUnoObjectsContext;
					if (a_underlyingUnoObject == null) {
						throw new System.Exception (UnoMessagesConstantsGroup.c_unoDocumentNotSpecified);
					}
					i_underlyingUnoObject = a_underlyingUnoObject;
					i_unoController = new UnoObjectPointer <XController> (i_underlyingUnoObject.getAddress ().getCurrentController ());
					i_unoFrame = new UnoFrame (i_remoteUnoObjectsContext, new UnoObjectPointer <XFrame> (i_unoController.getAddress ().getFrame ()));
					i_macrosProvider = new UnoObjectPointer <XScriptProvider> (i_underlyingUnoObject.getAddress <XScriptProviderSupplier> ().getScriptProvider ());
				}
				
				~UnoDocument () {
				}
				
				public static UnoDocument openDocumentFile (UnoDesktop a_unoDesktop, String a_fileUrl, String a_password, Boolean a_unoDocumentIsHidden) {
					return new UnoDocument (a_unoDesktop.getRemoteUnoObjectsContext (), a_unoDesktop.loadUnoDocument (a_fileUrl, a_password, a_unoDocumentIsHidden));
				}
				
				/*
				protected static XComponent createUnoDocumentOrOpenUnoDocumentFile (RemoteUnoObjectsContext a_remoteUnoObjectsContext, String a_fileUrl, String a_password, Boolean a_hiddenly) {
					XComponentLoader l_desktopInXComponentLoader = (XComponentLoader) a_remoteUnoObjectsContext.getUnoServiceInstance (UnoServiceNamesConstantsGroup.c_com_sun_star_frame_Desktop, null);
					return l_desktopInXComponentLoader.loadComponentFromURL (RegularExpressionsConstantsGroup.c_windowsDirectoryDelimiterRegularExpression.Replace (a_fileUrl, GeneralConstantsConstantsGroup.c_linuxDirectoriesDelimiter.ToString ()), UnoSpecialFrameNamesConstantsGroup.c_new, FrameSearchFlag.CREATE, UnoPropertiesHandler.buildPropertiesArray (UnoDocumentOpeningEnumerablePropertyNamesSet.c_instance.getValues (), ListsFactory.createList <Any> (UnoDatumConverter.getAny (false), UnoDatumConverter.getAny (a_hiddenly), UnoDatumConverter.getAny (false), UnoDatumConverter.getAny (a_hiddenly), UnoDatumConverter.getAny (a_password != null ? a_password: ""))));
				}
				*/
				
				public static UnoDocument getCurrentDocument (UnoDesktop a_unoDesktop) {
					return new UnoDocument (a_unoDesktop.getRemoteUnoObjectsContext (), a_unoDesktop.getCurrentDocument ());
				}
				
				/*
				protected static XComponent getUnoDocument (RemoteUnoObjectsContext a_remoteUnoObjectsContext, String a_fileName) throws Exception {
					XDesktop2 l_desktopInXDesktop2 = (XDesktop2) a_remoteUnoObjectsContext.getUnoServiceInstance (UnoServiceNamesConstantsGroup.c_com_sun_star_frame_Desktop, XDesktop2.class, null);
					XEnumeration l_unoComponentsInXEnumeration = l_desktopInXDesktop2.getComponents ().createEnumeration ();
					while (l_unoComponentsInXEnumeration.hasMoreElements ()) {
						XStorable2 l_unoComponentInXStorable2 = null;
						try {
							l_unoComponentInXStorable2 = (XStorable2) UnoRuntime.queryInterface (XStorable2.class, l_unoComponentsInXEnumeration.nextElement ());
						}
						catch (NoSuchElementException | WrappedTargetException l_exception) {
							// Practically, never would happen
							break;
						}
						if (l_unoComponentInXStorable2 == null) {
							continue;
						}
						try {
							if (Paths.get (l_unoComponentInXStorable2.getLocation ()).getFileName ().toString ().equals (a_fileName)) {
								return (XComponent) UnoRuntime.queryInterface (XComponent.class, l_unoComponentInXStorable2);
							}
						}
						// The possibility is that 'getLocation' returned null.
						catch (IllegalArgumentException l_exception) {
							continue;
						}
					}
					return null;
				}
				*/
				
				public RemoteUnoObjectsContext getRemoteUnoObjectsContext () {
					return i_remoteUnoObjectsContext;
				}
				
				public UnoObjectPointer <XModel> getUnderlyingUnoObject () {
					return i_underlyingUnoObject;
				}
				
				/*
				public XDispatchProvider getFrameInXDispatchProvider () {
					return i_unoFrameInXDispatchProvider;
				}
				
				public String getLocationUrl () {
					return i_unoDocumentInXStorable2.getLocation ();
				}
				
				public void addDocumentEventsListener (XDocumentEventListener a_eventListener) {
					i_unoDocumentInXDocumentEventBroadcaster.addDocumentEventListener (a_eventListener);
				}
				
				public void removeDocumentEventsListener (XDocumentEventListener a_eventListener) {
					i_unoDocumentInXDocumentEventBroadcaster.removeDocumentEventListener (a_eventListener);
				}
				*/
				
				public UnoFrame getUnoFrame () {
					return i_unoFrame;
				}
				
				public void store () {
					//i_selfInXStorable2.storeSelf (new PropertyValue [0]);
					storeAtUrl (getUrl ());
				}
				
				public void storeAtUrl (String a_fileUrl) {
					i_underlyingUnoObject.getAddress <XStorable2> ().storeToURL (RegularExpressionsConstantsGroup.c_windowsDirectoryDelimiterRegularExpression.Replace (a_fileUrl, GeneralConstantsConstantsGroup.c_linuxDirectoriesDelimiter.ToString ()), new PropertyValue [0]);
				}
				
				// Use UnoSpreadSheetsDocumentStoringFilterNamesConstantsGroup for a_filterName.
				public void storeAtUrl (String a_fileUrl, String a_filterName, Object a_filterData) {
					i_underlyingUnoObject.getAddress <XStorable2> ().storeToURL (RegularExpressionsConstantsGroup.c_windowsDirectoryDelimiterRegularExpression.Replace (a_fileUrl, GeneralConstantsConstantsGroup.c_linuxDirectoriesDelimiter.ToString ()), UnoPropertiesHandler.buildPropertiesArray (UnoDocumentStoringEnumerablePropertyNamesSet.c_instance.getValues (), ListsFactory.createList <Any> (UnoDatumConverter.getAny (a_filterName), UnoDatumConverter.getAny (a_filterData))));
				}
				
				public String getUrl () {
					return i_underlyingUnoObject.getAddress <XStorable2> ().getLocation ();
				}
				
				public void addEventsListener (UnoObjectPointer <XDocumentEventListener> a_eventsListener) {
					i_underlyingUnoObject.getAddress <XDocumentEventBroadcaster> ().addDocumentEventListener (a_eventsListener.getAddress ());
				}
				
				public void removeEventsListener (UnoObjectPointer <XDocumentEventListener> a_eventsListener) {
					i_underlyingUnoObject.getAddress <XDocumentEventBroadcaster> ().removeDocumentEventListener (a_eventsListener.getAddress ());
				}
				
				public void close () {
					i_underlyingUnoObject.getAddress <XCloseable> ().close (false);
				}
				
				/*
				public XNotifyingDispatch getDispatcher (unoidl.com.sun.star.util.URL a_urlInURL) {
					return (XNotifyingDispatch) i_unoFrameInXDispatchProvider.queryDispatch (a_urlInURL, UnoSpecialFrameNamesConstantsGroup.c_self, GeneralConstantsConstantsGroup.c_unspecifiedInteger);
				}
				
				public UnoDispatchResultAndRelatedInformation fulfill (UnoDispatchSlotsConstantsGroup.BaseUnoDispatchSlot a_unoDispatchSlot, List <Any> a_unoDispatchArgumentValues) {
					lock (this) {
						i_unoDispatchResultAndRelatedInformation = new UnoDispatchResultAndRelatedInformation ();
						if (UnoFulfiller.fulfill (i_unoFrameInXDispatchProvider, this, this, a_unoDispatchSlot, a_unoDispatchArgumentValues)) {
						}
						else {
							i_unoDispatchResultAndRelatedInformation = null;
						}
						return i_unoDispatchResultAndRelatedInformation;
					}
				}
				
				public void dispatchFinished (DispatchResultEvent a_unoDispatchResultEvent) {
					i_unoDispatchResultAndRelatedInformation.setResult (a_unoDispatchResultEvent);
				}
				
				public void statusChanged (FeatureStateEvent a_relatedInformationPieceEvent) {
					i_unoDispatchResultAndRelatedInformation.addRelatedInformationPiece (a_relatedInformationPieceEvent);
				}
				
				public void disposing (unoidl.com.sun.star.lang.EventObject a_source) {
				}
				*/
				
				public Any invokeMacro (String a_macroProgrammingLanguageName, String a_macroPathString, Any [] a_macroArgumentsArray, short [] a_macroOutputArgumentIndexesArray, Any [] a_macroOutputArgumentsArray) {
					String l_macroUrl = String.Format (UnoGeneralConstantsConstantsGroup.c_macroUrlFormat, a_macroPathString, a_macroProgrammingLanguageName, UnoMacroLocationNamesConstantsGroup.c_document);
					UnoObjectPointer <XScript> l_macroHandler = new UnoObjectPointer <XScript> (i_macrosProvider.getAddress ().getScript (l_macroUrl));
					return l_macroHandler.getAddress ().invoke (a_macroArgumentsArray, out a_macroOutputArgumentIndexesArray, out a_macroOutputArgumentsArray);
				}
			}
		}
	}
}

