namespace theBiasPlanet {
	namespace unoUtilities {
		namespace documents {
			using System;
			using System.Collections.Generic;
			using unoidl.com.sun.star.frame;
			using unoidl.com.sun.star.lang;
			using unoidl.com.sun.star.sheet;
			using unoidl.com.sun.star.util;
			using theBiasPlanet.coreUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.displayElements;
			using theBiasPlanet.unoUtilities.pointers;
			using theBiasPlanet.unoUtilities.unoObjectsContexts;
			
			public class UnoSpreadSheetsDocument: UnoDocument {
				/*
				private XSpreadsheetDocument i_unoSpreadSheetsDocumentInXSpreadsheetDocument;
				private XSpreadsheetView i_unoControllerInXSpreadsheetView;
				private XSpreadsheets i_unoSpreadSheetsInXSpreadsheets;
				*/
				private UnoObjectPointer <XSpreadsheets> i_sheets = null;
				//private XDispatchHelper i_dispatchHelperInXDispatchHelper;
				private Locale i_defaultLocale;
				private UnoObjectPointer <XNumberFormats> i_cellValueExpressionFormats = null;
				private Int32 i_dateExpressionFormatKey;
				private Int32 i_timeExpressionFormatKey;
				private Int32 i_dateAndTimeExpressionFormatKey;
				private Int32 i_booleanExpressionFormatKey;
				private Int32 i_stringExpressionFormatKey;
				private Int32 i_integerExpressionFormatKey;
				private Dictionary <Int32, Int32> i_numberOfDecimalPlacesToDoubleExpressionFormatKeyMap;
				private Dictionary <Int32, Int32> i_doubleExpressionFormatKeyToNumberOfDecimalPlacesMap;
				
				public static UnoSpreadSheetsDocument createDocument (UnoDesktop a_unoDesktop, Boolean a_unoDocumentIsHidden) {
					return new UnoSpreadSheetsDocument (a_unoDesktop.getRemoteUnoObjectsContext (), a_unoDesktop.loadUnoDocument (UnoSpecialFileUrlsConstantsGroup.c_calcNewDocument, null, a_unoDocumentIsHidden));
				}
				
				public static UnoSpreadSheetsDocument openFile (UnoDesktop a_unoDesktop, String a_fileUrl, String a_password, Boolean a_unoDocumentIsHidden) {
					return new UnoSpreadSheetsDocument (a_unoDesktop.getRemoteUnoObjectsContext (), a_unoDesktop.loadUnoDocument (a_fileUrl, a_password, a_unoDocumentIsHidden));
				}
				
				public new static UnoSpreadSheetsDocument getCurrentDocument (UnoDesktop a_unoDesktop) {
					return new UnoSpreadSheetsDocument (a_unoDesktop.getRemoteUnoObjectsContext (), a_unoDesktop.getCurrentDocument ());
				}
				
				public static UnoSpreadSheetsDocument getDocument (UnoDesktop a_unoDesktop, String a_fileName) {
					return new UnoSpreadSheetsDocument (a_unoDesktop.getRemoteUnoObjectsContext (), a_unoDesktop.getDocument (a_fileName));
				}
				
				public UnoSpreadSheetsDocument (RemoteUnoObjectsContext a_remoteUnoObjectsContext, UnoObjectPointer <XModel> a_underlyingUnoObject): base (a_remoteUnoObjectsContext, a_underlyingUnoObject) {
					if (i_underlyingUnoObject.getAddress <XSpreadsheetDocument> () == null) {
						throw new System.Exception (UnoMessagesConstantsGroup.c_isNotSpreadSheetsDocument);
					}
					i_defaultLocale = new Locale ();
					i_cellValueExpressionFormats = new UnoObjectPointer <XNumberFormats> (i_underlyingUnoObject.getAddress <XNumberFormatsSupplier> ().getNumberFormats ());
					i_dateExpressionFormatKey = getAndSetIfNecessaryCellValueExpressionFormatKey (UnoSpreadSheetCellFormatStringsConstantsGroup.c_standardDate);
					i_timeExpressionFormatKey = getAndSetIfNecessaryCellValueExpressionFormatKey (UnoSpreadSheetCellFormatStringsConstantsGroup.c_standardTime);
					i_dateAndTimeExpressionFormatKey = getAndSetIfNecessaryCellValueExpressionFormatKey (UnoSpreadSheetCellFormatStringsConstantsGroup.c_standardDateAndTime);
					i_booleanExpressionFormatKey = getAndSetIfNecessaryCellValueExpressionFormatKey (UnoSpreadSheetCellFormatStringsConstantsGroup.c_standardBoolean);
					i_stringExpressionFormatKey = getAndSetIfNecessaryCellValueExpressionFormatKey (UnoSpreadSheetCellFormatStringsConstantsGroup.c_standardString);
					i_integerExpressionFormatKey = getAndSetIfNecessaryCellValueExpressionFormatKey (UnoSpreadSheetCellFormatStringsConstantsGroup.c_standardInteger);
					i_numberOfDecimalPlacesToDoubleExpressionFormatKeyMap = new Dictionary <Int32, Int32> ();
					i_doubleExpressionFormatKeyToNumberOfDecimalPlacesMap = new Dictionary <Int32, Int32> ();
					int l_doubleDefaultExpressionFormatKey = GeneralConstantsConstantsGroup.c_unspecifiedInteger;
					l_doubleDefaultExpressionFormatKey = i_cellValueExpressionFormats.getAddress ().queryKey (UnoSpreadSheetCellFormatStringsConstantsGroup.c_globalNumber, i_defaultLocale, false);
					if (l_doubleDefaultExpressionFormatKey == GeneralConstantsConstantsGroup.c_unspecifiedInteger) {
						l_doubleDefaultExpressionFormatKey = i_cellValueExpressionFormats.getAddress ().queryKey (UnoSpreadSheetCellFormatStringsConstantsGroup.c_standardNumber, i_defaultLocale, false);
					}
					if (l_doubleDefaultExpressionFormatKey == GeneralConstantsConstantsGroup.c_unspecifiedInteger) {
						// Doesn't seem possible
					}
					else {
						Int32 l_defaultNumberOfDecimalPlaces = GeneralConstantsConstantsGroup.c_unspecifiedInteger;
						Int32 l_doubleDefaultExpressionFormatKeyInInteger = l_doubleDefaultExpressionFormatKey;
						i_numberOfDecimalPlacesToDoubleExpressionFormatKeyMap.Add (l_defaultNumberOfDecimalPlaces, l_doubleDefaultExpressionFormatKeyInInteger);
						i_doubleExpressionFormatKeyToNumberOfDecimalPlacesMap.Add (l_doubleDefaultExpressionFormatKeyInInteger, l_defaultNumberOfDecimalPlaces);
					}
					i_sheets = new UnoObjectPointer <XSpreadsheets> (i_underlyingUnoObject.getAddress <XSpreadsheetDocument> ().getSheets ());
				}
				
				private int getAndSetIfNecessaryCellValueExpressionFormatKey (String a_formatString) {
					Int32 l_formatKey = i_cellValueExpressionFormats.getAddress ().queryKey (a_formatString, i_defaultLocale, false);
					if (l_formatKey == GeneralConstantsConstantsGroup.c_unspecifiedInteger) {
						l_formatKey = i_cellValueExpressionFormats.getAddress ().addNew (a_formatString, i_defaultLocale);
					}
					return l_formatKey;
				}
				
				/*
				public static UnoSpreadSheetsDocument openSpreadSheetsDocumentFile (RemoteUnoObjectsContext a_remoteUnoObjectsContext, String a_fileUrl, String a_password, bool a_hiddenly) {
					return new UnoSpreadSheetsDocument (a_remoteUnoObjectsContext, UnoDocument.createUnoDocumentOrOpenUnoDocumentFile (a_remoteUnoObjectsContext, a_fileUrl, a_password, a_hiddenly));
				}
				*/
			}
		}
	}
}

