namespace theBiasPlanet {
	namespace unoUtilities {
		namespace documentsHandling {
			using System;
			using uno;
			using unoidl.com.sun.star.container;
			using unoidl.com.sun.star.frame;
			using unoidl.com.sun.star.lang;
			using unoidl.com.sun.star.sheet;
			using theBiasPlanet.coreUtilities.constantsGroups;
			using theBiasPlanet.coreUtilities.messagingHandling;
			using theBiasPlanet.unoUtilities.pointers;
			using theBiasPlanet.unoUtilities.unoObjectsContexts;
			
			public class UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor: UnoDocumentTailor {
				private Int32 i_targetSpreadSheetIndex;
				
				public UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor (RemoteUnoObjectsContext a_remoteUnoObjectsContext, Int32 a_targetSpreadSheetIndex): base (a_remoteUnoObjectsContext) {
					i_targetSpreadSheetIndex = a_targetSpreadSheetIndex;
				}
				
				public override Boolean tailor (UnoObjectPointer <XModel> a_unoDocument) {
					if (a_unoDocument.getAddress <XSpreadsheetDocument> () == null) {
						Publisher.logErrorInformation ("The document is not any spread sheets document.");
						return false;
					}
					else {
						UnoObjectPointer <XIndexAccess> l_spreadSheets = new UnoObjectPointer <XIndexAccess> (a_unoDocument.getAddress <XSpreadsheetDocument> ().getSheets ());
						try {
							UnoObjectPointer <XSpreadsheet> l_spreadSheet = new UnoObjectPointer <XSpreadsheet> ( (XSpreadsheet) ( ( (Any) l_spreadSheets.getAddress ().getByIndex (i_targetSpreadSheetIndex)).Value));
							l_spreadSheets.getAddress <XSpreadsheets> ().moveByName (l_spreadSheet.getAddress <XNamed> ().getName (), (Int16) GeneralConstantsConstantsGroup.c_iterationStartNumber);
							return true;
						}
						catch (Exception l_exception) {
							Publisher.logErrorInformation (l_exception);
							return false;
						}
					}
				}
			}
		}
	}
}

