namespace theBiasPlanet {
	namespace unoUtilities {
		namespace inspectionsHandling {
			using System;
			using System.Collections.Generic;
			using System.Text;
			using unoidl.com.sun.star.beans;
			using unoidl.com.sun.star.lang;
			using unoidl.com.sun.star.uno;
			using theBiasPlanet.coreUtilities.collections;
			using theBiasPlanet.unoUtilities.pointers;
			
			public class UnoComponentInspector {
				public static List <String> getUnoTypeNames (Object a_unoObjectInXInterface) {
					try {
						XTypeProvider l_unoObjectInXTypeProvider = (XTypeProvider) a_unoObjectInXInterface;
						try {
							Type [] l_UnoTypes = l_unoObjectInXTypeProvider.getTypes ();
							int l_numberOfUnoTypes = l_UnoTypes.Length;
							List <String> l_unoTypeNames = new List <String> ();
							for (int l_unoTypeIndex = 0; l_unoTypeIndex < l_numberOfUnoTypes; l_unoTypeIndex ++) {
								l_unoTypeNames.Add (l_UnoTypes [l_unoTypeIndex].FullName);
							}
							return l_unoTypeNames;
						}
						catch (unoidl.com.sun.star.uno.RuntimeException l_exception) {
							// I do not understand why this happens.
							throw new UnoInterfaceNotImplementedException (String.Format ("{0:s} for {1:s}", l_exception.ToString (), "XTypeProvider"));
						}
					}
					catch (InvalidCastException) {
						throw new UnoInterfaceNotImplementedException ("XTypeProvider");
					}
				}
				
				public static NavigableLinkedHashMap <String, Object> getPropertyNameToValueMap (Object a_unoObjectInXInterface) {
					try {
						XPropertySet l_unoObjectInXPropertySet = (XPropertySet) a_unoObjectInXInterface;
						NavigableLinkedHashMap <String, Object> l_propertyNameToValueMap = new NavigableLinkedHashMap <String, Object> ();
						// do not use 'UnoObjectPointer' for storing 'l_propertySetInfoInXPropertySetInfo', because an eternal loop would happen.
						XPropertySetInfo l_propertySetInfoInXPropertySetInfo = l_unoObjectInXPropertySet.getPropertySetInfo ();
						if (l_propertySetInfoInXPropertySetInfo != null) {
							Property [] l_properties = l_propertySetInfoInXPropertySetInfo.getProperties ();
							int l_numberOfProperties = l_properties.Length;
							for (int l_propertyIndex = 0; l_propertyIndex < l_numberOfProperties; l_propertyIndex ++) {
								try {
									l_propertyNameToValueMap.put (l_properties [l_propertyIndex].Name, l_unoObjectInXPropertySet.getPropertyValue (l_properties [l_propertyIndex].Name));
								}
								catch (UnknownPropertyException) {
									l_propertyNameToValueMap.put (l_properties [l_propertyIndex].Name, "Not Found");
								}
								catch (System.Exception l_exception) {
									l_propertyNameToValueMap.put (l_properties [l_propertyIndex].Name, String.Format (": ### An error has occurred in getting the property value: exception is {0:s}.", l_exception));
								}
							}
							return l_propertyNameToValueMap;
						}
						else {
							return l_propertyNameToValueMap;
						}
					}
					catch (InvalidCastException) {
						throw new UnoInterfaceNotImplementedException ("XPropertySet");
					}
				}
			}
		}
	}
}

