namespace theBiasPlanet {
	namespace unoUtilities {
		namespace unoObjectsContexts {
			using System;
			using System.Collections.Generic;
			using uno;
			using unoidl.com.sun.star.container;
			using unoidl.com.sun.star.lang;
			using unoidl.com.sun.star.uno;
			using theBiasPlanet.coreUtilities.collections;
			using theBiasPlanet.unoUtilities.constantsGroups.propertyNamesSets;
			using theBiasPlanet.unoUtilities.unoComponentBases;
			
			abstract public class UnoObjectsContext: UnoComponentBase, XComponentContext {
				protected NavigableLinkedHashMap <String, Object> i_localPropertyNameToValueMap;
				
				public UnoObjectsContext (String a_unoConnectionIdentification) {
					i_localPropertyNameToValueMap =  new NavigableLinkedHashMap <String, Object> ();
					addLocalProperty (UnoObjectsContextPropertyNamesSet.c_unoConnectionIdentification_string, a_unoConnectionIdentification);
				}
				
				~UnoObjectsContext () {
				}
				
				abstract public Any getValueByName (String a_propertyName);
				
				abstract public void addExtraGlobalProperty (String a_propertyName, Any a_propertyValue);
				
				abstract public void removeExtraGlobalProperty (String a_propertyName);
				
				abstract public XMultiComponentFactory getServiceManager ();
				
				virtual public Object getLocalPropertyValue (String a_propertyName) {
					return i_localPropertyNameToValueMap [a_propertyName];
				}
				
				virtual public void addLocalProperty (String a_propertyName, Object a_propertyValue) {
					i_localPropertyNameToValueMap.Add (a_propertyName, a_propertyValue);
				}
				
				virtual public void removeLocalProperty (String a_propertyName) {
					i_localPropertyNameToValueMap.Remove (a_propertyName);
				}
				
				virtual public bool isFromSameOrigin (UnoObjectsContext a_comparedUnoObjectsContext) {
					if (a_comparedUnoObjectsContext ==  null) {
						return false;
					}
					String l_unoConnectionIdentification = (String) getLocalPropertyValue (UnoObjectsContextPropertyNamesSet.c_unoConnectionIdentification_string);
					if (l_unoConnectionIdentification == null) {
						return false;
					}
					if (l_unoConnectionIdentification.Equals (a_comparedUnoObjectsContext.getLocalPropertyValue (UnoObjectsContextPropertyNamesSet.c_unoConnectionIdentification_string))) {
						return true;
					}
					return false;
				}
			}
		}
	}
}

