from com.sun.star.datatransfer.clipboard import XSystemClipboard
from theBiasPlanet.unoUtilities.clipboardHandling.UnoClipboardFormatSpecificDataComposite import UnoClipboardFormatSpecificDataComposite
from theBiasPlanet.unoUtilities.constantsGroups.UnoServiceNamesConstantsGroup import UnoServiceNamesConstantsGroup
from theBiasPlanet.unoUtilities.pointers.UnoObjectPointer import UnoObjectPointer
from theBiasPlanet.unoUtilities.unoObjectsContexts.RemoteUnoObjectsContextInterface import RemoteUnoObjectsContextInterface

class UnoClipboard:
	s_unoClipboard: "UnoObjectPointer [XSystemClipboard]" = None
	
	@staticmethod
	def openClipboard (a_remoteUnoObjectsContext: "RemoteUnoObjectsContextInterface") -> bool:
		UnoClipboard.s_unoClipboard = a_remoteUnoObjectsContext.getUnoServiceInstance (XSystemClipboard, UnoServiceNamesConstantsGroup.c_com_sun_star_datatransfer_clipboard_SystemClipboard, None)
		return True
	
	@staticmethod
	def closeClipboard () -> bool:
		UnoClipboard.s_unoClipboard = None
		return True
	
	@staticmethod
	def clearClipboard () ->bool:
		UnoClipboard.s_unoClipboard.getAddress ().setContents (None, None)
		return True
	
	@staticmethod
	def getFormatSpecificDataComposite () -> "UnoClipboardFormatSpecificDataComposite":
		return UnoClipboardFormatSpecificDataComposite (UnoClipboard.s_unoClipboard.getAddress ().getContents ())
	
	@staticmethod
	def setFormatSpecificDataComposite (a_formatSpecificDataComposite: "UnoClipboardFormatSpecificDataComposite") -> bool:
		UnoClipboard.s_unoClipboard.getAddress ().setContents (a_formatSpecificDataComposite.getUnderlyingObject (), None)
		return True

