from typing import Iterator
from typing import List
from typing import Optional
from typing import Type
from typing import TypeVar
import uno
from com.sun.star.beans import PropertyValue
from theBiasPlanet.coreUtilities.constantsGroups.GeneralConstantsConstantsGroup import GeneralConstantsConstantsGroup
from theBiasPlanet.unoUtilities.property.UnoProperty import UnoProperty
from theBiasPlanet.unoUtilities.unoDataHandling.UnoDatumConverter import UnoDatumConverter

class UnoPropertiesHandler:
	@staticmethod
	def buildProperties (a_propertyNames: List [str], a_propertyValues: List [object]) -> Optional [List [PropertyValue]]:
		if (a_propertyNames is None or a_propertyValues is None):
			return None
		else:
			l_properties: List [PropertyValue] = []
			l_propertyValuesIterator: Iterator [object] = iter (a_propertyValues)
			l_propertyName: str
			l_propertyValue: object
			for l_propertyName in a_propertyNames:
				l_propertyValue = next (l_propertyValuesIterator)
				if not (l_propertyValue is None):
					if not (isinstance (l_propertyValue, str) and l_propertyValue == ""):
						if not l_propertyName.startswith ("#"):
							l_properties.append (UnoProperty (l_propertyName, l_propertyValue))
						else:
							l_properties.append (UnoProperty ("", l_propertyValue, int (l_propertyName [1], base=10)))
			return l_properties

