from typing import Dict
from typing import List
from typing import Optional
from typing import Type
from typing import TypeVar
from typing import cast
from com.sun.star.container import XNameContainer
from com.sun.star.lang import XMultiComponentFactory
from com.sun.star.lang import XSingleComponentFactory
from com.sun.star.uno import XComponentContext
from com.sun.star.uno import XInterface
from theBiasPlanet.unoUtilities.pointers.UnoObjectPointer import UnoObjectPointer
from theBiasPlanet.unoUtilities.unoObjectsContexts.UnoObjectsContext import UnoObjectsContext

T = TypeVar ("T", bound="XInterface")

class LocalUnoObjectsContext (UnoObjectsContext):
	def __init__ (a_this: "LocalUnoObjectsContext", a_underlyingUnoObject: XComponentContext, a_unoConnectionIdentification: str) -> None:
		a_this.i_underlyingUnoObject: XComponentContext
		a_this.i_unoGlobalServicesManager: XMultiComponentFactory
		
		super ().__init__ (a_unoConnectionIdentification)
		a_this.i_underlyingUnoObject = a_underlyingUnoObject
		a_this.i_unoGlobalServicesManager = a_this.i_underlyingUnoObject.getServiceManager ()
	
	def __del__ (a_this: "LocalUnoObjectsContext") -> None:
		None
	
	def getUnderlyingUnoObject (a_this: "LocalUnoObjectsContext") -> "XComponentContext":
		return a_this.i_underlyingUnoObject
	
	def getValueByName (a_this: "LocalUnoObjectsContext", a_propertyName: str) -> object:
		return a_this.i_underlyingUnoObject.getValueByName (a_propertyName)
	
	def addExtraGlobalProperty (a_this: "LocalUnoObjectsContext", a_propertyName: str, a_propertyValue: object) -> None:
		cast (XNameContainer, a_this.i_underlyingUnoObject).insertByName (a_propertyName, a_propertyValue)
	
	def removeExtraGlobalProperty (a_this: "LocalUnoObjectsContext", a_propertyName: str) -> None:
		cast (XNameContainer, a_this.i_underlyingUnoObject).removeByName  (a_propertyName)
	
	def getServiceManager (a_this: "LocalUnoObjectsContext") -> XMultiComponentFactory:
		return a_this.i_underlyingUnoObject.getServiceManager ()
	
	def getUnoServiceInstance (a_this: "UnoObjectsContext", a_type0: Type [T], a_unoServiceName: str, a_unoServiceInstantiationArguments: Optional [List [object]]) -> T:
		if a_type0 is None:
			return None
		if a_unoServiceInstantiationArguments is None:
			return cast (T, a_this.getServiceManager ().createInstanceWithContext (a_unoServiceName, a_this))
		else:
			return cast (T, a_this.getServiceManager ().createInstanceWithArgumentsAndContext (a_unoServiceName, a_unoServiceInstantiationArguments, a_this))
	
	def addGlobalUnoService (a_this: "LocalUnoObjectsContext", a_globalUnoServiceInstancesFactory: XSingleComponentFactory) -> bool:
		return None
	
	def addGlobalUnoServices (a_this: "LocalUnoObjectsContext", a_globalUnoServiceInstancesFactoriesConfigurationFileUrl: str) -> bool:
		return None

