from typing import Dict
from typing import cast
from abc import ABCMeta
from abc import abstractmethod
import uno
from com.sun.star.lang import XMultiComponentFactory
from com.sun.star.uno import XComponentContext
from theBiasPlanet.unoUtilities.constantsGroups.propertyNamesSets.UnoObjectsContextPropertyNamesSet import UnoObjectsContextPropertyNamesSet
from theBiasPlanet.unoUtilities.pointers.UnoObjectPointer import UnoObjectPointer
from theBiasPlanet.unoUtilities.unoComponentBases.UnoComponentBase import UnoComponentBase
from theBiasPlanet.unoUtilities.unoDataHandling.UnoDatumConverter import UnoDatumConverter

class UnoObjectsContext (UnoComponentBase, XComponentContext, metaclass=ABCMeta):
	def __init__ (a_this: "UnoObjectsContext", a_unoConnectionIdentification: str) -> None:
		a_this.i_localPropertyNameToValueMap: Dict [str, object]
		
		a_this.i_localPropertyNameToValueMap = dict ()
		a_this.addLocalProperty (UnoObjectsContextPropertyNamesSet.c_unoConnectionIdentification_string, a_unoConnectionIdentification)
	
	def __del__ (a_this: "UnoObjectsContext") -> None:
		None
	
	@abstractmethod
	def getValueByName (a_this: "UnoObjectsContext", a_propertyName: str) -> object:
		return None
	
	@abstractmethod
	def addExtraGlobalProperty (a_this: "UnoObjectsContext", a_propertyName: str, a_propertyValue: object) -> None:
		None
	
	@abstractmethod
	def removeExtraGlobalProperty (a_this: "UnoObjectsContext", a_propertyName: str) -> None:
		None
	
	def getLocalPropertyValue (a_this: "UnoObjectsContext", a_propertyName: str) -> object:
		return a_this.i_localPropertyNameToValueMap [a_propertyName]
	
	def addLocalProperty (a_this: "UnoObjectsContext", a_propertyName: str, a_propertyValue: object) -> None:
		a_this.i_localPropertyNameToValueMap.update ( {a_propertyName: a_propertyValue})
	
	def removeLocalProperty (a_this: "UnoObjectsContext", a_propertyName: str) -> None:
		a_this.i_localPropertyNameToValueMap.pop (a_propertyName)
	
	def isFromSameOrigin (a_this: "UnoObjectsContext", a_comparedUnoObjectsContext: "UnoObjectsContext") -> bool:
		if (a_comparedUnoObjectsContext is None):
			return False
		try:
			l_unoConnectionIdentification: str = cast (str, UnoDatumConverter.getObject (a_this.getLocalPropertyValue (UnoObjectsContextPropertyNamesSet.c_unoConnectionIdentification_string)))
			if l_unoConnectionIdentification is None:
				return False
			if l_unoConnectionIdentification == UnoDatumConverter.getObject (a_comparedUnoObjectsContext.getLocalPropertyValue (UnoObjectsContextPropertyNamesSet.c_unoConnectionIdentification_string)):
				return True
		except (Exception) as l_exception:
			return False
		return False

